'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Afx text clipboard Demo using Fred's String (fstring) class.
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "TCLIB.BAT $FILE$"
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
'Tell the translator to include these Functions
$USE USE_AfxGetClipboardText USE_AfxSetClipboardText
'------------------------------------------------------------------------------
$Include <Afx/CWindow.bi>
'==============================================================================
CONST IDC_SAVEIT = 1001
CONST IDC_GETIT = 1002
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	' // Creates the main window
	Raw As CWindow pWindow
	hWin = pWindow.Create(NULL, "CWindow with a button", &WndProc,500,300)
	pWindow.SetClientSize(500, 320)
	pWindow.Center()
	
	pWindow.AddControl("Button",hWin, IDC_SAVEIT, "Save It", 350, 150, 75, 23)
	pWindow.AddControl("Button",hWin, IDC_GETIT, "Get It", 350, 200, 75, 23)
	pWindow.AddControl("Button",hWin, IDCANCEL, "&Close", 350, 250, 75, 23)
	' // Dispatch messages
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function
'==============================================================================
CallBack Function WndProc()
	Dim sTxt$
	Select Case Msg
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDC_SAVEIT
					Raw As fstring fs("Here is some text from the clipboard")
					AfxSetClipboardText(fs.lpStr())
					MsgBox("text saved to clipboard")
					Exit Function
				Case IDC_GETIT
					Raw As fstring fs(AfxGetClipboardText())
					MsgBox(fs.lpStr())
					Exit Function
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
