// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.5.6 (2016/09/09)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-1) 5.1.0
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with the
//           Microsoft (R) C/C++ Optimizing Compiler
//                           On MS Windows
//                    Using TCLib by Fred Harris
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#define _X(y) y
#include <windows.h>
#define   x64
#include "TCLib\stdio.h"
#include "TCLib\string.h"
#include "TCLib\stdlib.h"
#include "TCLib\memory.h"
#include "TCLib\malloc.h"
#include "TCLib\math.h"
#include "TCLib\tchar.h"
#include "TCLib\Strings.cpp"
typedef String fstring;
FILE* stdin;
FILE* stdout;
FILE* stderr;
//<---UNICODE AWARE
#define SFMT (const char*)"%s\r\n"
//>---UNICODE AWARE

// NO HEADERS START
#ifndef _WINDOWS_
//<---UNICODE AWARE
typedef _TCHAR *PCHAR, *LPCH, *PCH, *NPSTR, *LPSTR, *PSTR;
typedef unsigned long DWORD, *PDWORD, *LPDWORD;
typedef unsigned int UINT;
//>---UNICODE AWARE
#endif
// NO HEADERS END
// ***************************************************
// Compiler Defines
// ***************************************************
#ifndef __cplusplus
#error A C++ compiler is required
#endif
// $HEADER BEGIN
#include <commctrl.h>     /*'For CWindow*/
#pragma comment(lib,"comctl32.lib")  /*'For CWindow*/
#pragma comment(lib,"gdi32.lib")  /*'For CWindow*/
#pragma comment(lib,"advapi32.lib")  /*'For DPI aware check*/
// $HEADER END

typedef BOOL (*BC9_AfxIsProcessDPIAware)();

// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const _TCHAR* ccptr;
#define CCPTR const _TCHAR*
#define cfree free
//<---UNICODE AWARE
typedef char _char;
#define _strlen strlen
//>---UNICODE AWARE
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************

#define USEDLGMSG 1

// *************************************************
//               Standard Prototypes
// *************************************************

int     str_cmp(const _TCHAR*, const _TCHAR*);
_TCHAR*   BCX_TmpStr(size_t, size_t = 0, int = 1);
_TCHAR*   ucase (const _TCHAR*);
_TCHAR*   mid (const _TCHAR*, int, int = -1);
_TCHAR*   _strupr_(_TCHAR *);
_TCHAR*   _strlwr_(_TCHAR *);
_TCHAR*   left (const _TCHAR*, int);
_TCHAR*   str (double);
_TCHAR*   join (int, ... );

// *************************************************
//                System Variables
// *************************************************

// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************


class CWindow
{
private:
    HWND     m_hwnd = {0};
    HINSTANCE  m_hInstance = {0};
    HFONT    m_hFont = {0};
    HACCEL   m_hAccel = {0};
    long     m_DPI = 96;
    float    m_rx = 1;
    float    m_ry = 1;
    ATOM     m_wAtom = {0};
    _TCHAR     m_szClassName[260];
    long     m_DefaultFontSize = {0};
    _TCHAR     m_szDefaultFontName[260];
    LONG_PTR  m_rgUserData[99];
    ACCEL*   m_rgAccelEntries = {0};
#ifdef USEMDI
    HWND     m_hwndClient = {0};
    _TCHAR     fspMDIClassName[260];
#endif
    HMODULE  m_hRichEditLib = {0};

public:
    CWindow(_TCHAR* = _T("" ));
    ~CWindow(void);
    float   DPI(void);
    void   DPI(float);
    LONG_PTR   UserData(long);
    void   UserData(long, LONG_PTR);
    long   Do_Events(long);
    HWND   Create(HWND = NULL , _TCHAR* = _T("" ), WNDPROC = NULL , long = CW_USEDEFAULT , long = CW_USEDEFAULT , long = CW_USEDEFAULT , long = CW_USEDEFAULT , DWORD = WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS , DWORD = WS_EX_CONTROLPARENT | WS_EX_WINDOWEDGE );
    void   SetClientSize(long, long);
    void   Center(HWND = NULL , HWND = NULL );
    HWND   hWindow(void);
    void   hWindow(HWND);
    HINSTANCE   InstanceHandle(void);
    void   InstanceHandle(HINSTANCE);
    ULONG_PTR   ClassStyle(void);
    void   ClassStyle(ULONG_PTR);
    ULONG_PTR   WindowStyle(void);
    void   WindowStyle(ULONG_PTR);
    ULONG_PTR   WindowExStyle(void);
    void   WindowExStyle(ULONG_PTR);
    _TCHAR*   DefaultFontName(void);
    void   DefaultFontName(_TCHAR*);
    long   DefaultFontSize(void);
    void   DefaultFontSize(long);
    HFONT   Font(void);
    void   Font(HFONT);
    HBRUSH   Brush(void);
    void   Brush(HBRUSH);
    void   BigIcon(HICON);
    void   SmallIcon(HICON);
    float   rxRatio(void);
    void   rxRatio(float);
    float   ryRatio(void);
    void   ryRatio(float);
    float   ScaleX(float);
    float   ScaleY(float);
    float   UnScaleX(float);
    float   UnScaleY(float);
    long   Width(void);
    long   Height(void);
    long   ClientWidth(void);
    long   ClientHeight(void);
    long   ControlWidth(HWND);
    long   ControlHeight(HWND);
    long   ControlClientWidth(HWND);
    long   ControlClientHeight(HWND);
    void   GetWindowRect(LPRECT);
    RECT   GetWindowRect(void);
    void   GetClientRect(LPRECT);
    RECT   GetClientRect(void);
    void   GetControlWindowRect(HWND, LPRECT);
    RECT   GetControlWindowRect(HWND);
    void   GetControlClientRect(HWND, LPRECT);
    RECT   GetControlClientRect(HWND);
    void   GetWorkArea(LPRECT);
    RECT   GetWorkArea(void);
    HWND   ControlHandle(long);
    void   Resize(void);
    BOOL   SetWindowPos(HWND, HWND, long, long, long, long, UINT);
    BOOL   MoveWindow(HWND, long, long, long, long, BOOL);
    HFONT   CreateFont(_TCHAR*, long, long = 0 , BYTE = FALSE , BYTE = FALSE , BYTE = FALSE , BYTE = DEFAULT_CHARSET );
    BOOL   SetFont(_TCHAR*, long, long = 0 , BYTE = FALSE , BYTE = FALSE , BYTE = FALSE , BYTE = DEFAULT_CHARSET );
    HWND   AddControl(_TCHAR*, HWND = 0 , long = 0 , _TCHAR* = _T("" ), long = 0 , long = 0 , long = 0 , long = 0 , long = - 1 , long = - 1 , LONG_PTR = 0 , WNDPROC = NULL , UINT_PTR = 0xffffffff , DWORD_PTR = NULL );
    HACCEL   AccelHandle(void);
    void   AccelHandle(HACCEL);
    void   AddAccelerator(BYTE, WORD, WORD);
};


// *************************************************
//            User Global Variables
// *************************************************



// *************************************************
//               Standard Macros
// *************************************************

#define BAND &
#define BOR |


// *************************************************
//               User Prototypes
// *************************************************

void    AfxCenterWindow (HWND = NULL, HWND = NULL);
void    AfxSetWindowClientSize (HWND, long, long, float = 1, float = 1);
BOOL    AfxIsProcessDPIAware (void);
BOOL    AfxUseDpiScaling (void);
long    AfxWindowsVersion (void);
ATOM    CWindow_RegisterClass (_TCHAR*  , HINSTANCE, WNDPROC);
LRESULT CWindow_WindowProc (HWND, UINT, WPARAM, LPARAM);
CWindow* AfxCWindowPtr (HWND);
CWindow* AfxCWindowPtr (LPARAM);
CWindow* AfxCWindowPtr (CREATESTRUCT*);
CWindow* AfxCWindowOwnerPtr (HWND);
int     WINAPI _tWinMain (HINSTANCE, HINSTANCE, LPWSTR, int);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

// *************************************************
//            User Global Initialized Arrays
// *************************************************



// *************************************************
//                 Runtime Functions
// *************************************************

#ifndef BCXTmpStrSize
#define BCXTmpStrSize  2048
#endif
_TCHAR *BCX_TmpStr (size_t Bites, size_t  iPad, int iAlloc)
{
    static int   StrCnt;
    static _TCHAR *StrFunc[BCXTmpStrSize];
    StrCnt = (StrCnt + 1) & (BCXTmpStrSize - 1);
    if(StrFunc[StrCnt]) {
        free (StrFunc[StrCnt]);
        StrFunc[StrCnt] = NULL;
    }
#if defined BCX_MAX_VAR_SIZE
    if(Bites * sizeof(_TCHAR) > BCX_MAX_VAR_SIZE)
    {
        _tprintf(_T("Buffer Overflow caught in BCX_TmpStr - requested space of %d EXCEEDS %d\n"), (int)(Bites * sizeof(_TCHAR)), BCX_MAX_VAR_SIZE);
        abort();
    }
#endif
    if(iAlloc) StrFunc[StrCnt] = (_TCHAR*)calloc(Bites + iPad + 1, sizeof(_TCHAR));
    return StrFunc[StrCnt];
}


int str_cmp (const _TCHAR *a, const _TCHAR *b)
{
    register int counter = 0;
    for(;;)
    {
        if((a[counter]^b[counter]))
        {
            if((UINT) a[counter] >= (UINT) b[counter])
                return  1;
            return -1;
        }
        if(!a[counter]) return 0;
        counter++;
    }
}


_TCHAR *left (const _TCHAR *S, int length)
{
    register int tmplen = _tcslen(S);
    if(length < 1) return BCX_TmpStr(1, 0, 1);
    if(length < tmplen) tmplen = length;
    _TCHAR *strtmp = BCX_TmpStr(tmplen, 1, 1);
    return (_TCHAR*)wmemcpy(strtmp, S, tmplen);
}


_TCHAR *mid (const _TCHAR *S, int start, int length)
{
    _TCHAR *strtmp;
    register int tmplen = _tcslen(S);
    if(start > tmplen || start < 1) return BCX_TmpStr(1, 1, 1);
    if (length < 0 || length > (tmplen - start) + 1)
        length = (tmplen - start) + 1;
    strtmp = BCX_TmpStr(length, 1, 1);
    return (_TCHAR*)wmemcpy(strtmp, &S[start - 1], length);
}


_TCHAR *ucase (const _TCHAR *S)
{
    register _TCHAR *strtmp = BCX_TmpStr(_tcslen(S), 1, 1);
    return _strupr_(_tcscpy(strtmp, (_TCHAR*)S));
}


_TCHAR *str (double d)
{
    register _TCHAR *strtmp = BCX_TmpStr(24, 1, 1);
    _stprintf(strtmp, _T("%.15G"), d);
    return strtmp;
}


_TCHAR * join(int n, ...)
{
    register int i = n, tmplen = 0;
    register _TCHAR *s_;
    register _TCHAR *strtmp;
    va_list marker;
    va_start(marker, n); // Initialize variable arguments
    while(i-- > 0)
    {
        s_ = va_arg(marker, _TCHAR *);
        if(s_) tmplen += _tcslen(s_);
    }
    strtmp = BCX_TmpStr(tmplen, 1, 1);
    va_end(marker); // Reset variable arguments
    i = n;
    va_start(marker, n); // Initialize variable arguments
    while(i-- > 0)
    {
        s_ = va_arg(marker, _TCHAR *);
        if(s_) _tcscat(strtmp, s_);
    }
    va_end(marker); // Reset variable arguments
    return strtmp;
}


template<typename T>
T iif (BOOL cond, T  trueCase, T  falseCase)
{
    if(cond )
    {
        return trueCase;
    }
    return falseCase;
}
_TCHAR *_strupr_(_TCHAR *string)
{
    _TCHAR *s;

    if (string)
    {
        for(s = string; *s; ++s)
            *s = towupper(*s);
    }
    return string;
}

_TCHAR *_strlwr_(_TCHAR *string)
{
    _TCHAR *s;

    if (string)
    {
        for (s = string; *s; ++s)
            *s = towlower(*s);
    }
    return string;
}



// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

void AfxCenterWindow (HWND hwnd, HWND hwndParent)
{
    RECT     rc = {0};
    RECT     rcParent = {0};
    RECT     rcWorkArea = {0};
    POINT    pt = {0};
    GetWindowRect(hwnd, &rc);
    long     nWidth = rc.right - rc.left;
    long     nHeight = rc.bottom - rc.top;
    if(SystemParametersInfo(SPI_GETWORKAREA, sizeof(rcWorkArea), &rcWorkArea, 0) == 0 )
    {
        rcWorkArea.right = GetSystemMetrics( SM_CXSCREEN);
        rcWorkArea.bottom = GetSystemMetrics( SM_CYSCREEN);
    }
    if(hwndParent )
    {
        GetWindowRect(hwndParent, &rcParent);
    }
    else
    {
        rcParent.left = rcWorkArea.left;
        rcParent.top = rcWorkArea.top;
        rcParent.right = rcWorkArea.right;
        rcParent.bottom = rcWorkArea.bottom;
    }
    long     nParentWidth = rcParent.right - rcParent.left;
    long     nParentHeight = rcParent.bottom - rcParent.top;
    pt.x = rcParent.left + (( nParentWidth - nWidth) / 2);
    if((pt.x < rcWorkArea.left))
    {
        pt.x = rcWorkArea.left;
    }
    else if(((pt.x + nWidth) > rcWorkArea.right))
    {
        pt.x = rcWorkArea.right - nWidth;
    }
    pt.y = rcParent.top + (( nParentHeight - nHeight) / 2);
    if((pt.y < rcWorkArea.top))
    {
        pt.y = rcWorkArea.top;
    }
    else if(((pt.y + nHeight) > rcWorkArea.bottom))
    {
        pt.y = rcWorkArea.bottom - nHeight;
    }
    if((GetWindowLongPtr(hwnd, GWL_STYLE) BAND  WS_CHILD) == WS_CHILD )
    {
        ScreenToClient(hwndParent, &pt);
    }
    SetWindowPos(hwnd, NULL, pt.x, pt.y, 0, 0, SWP_NOSIZE  BOR  SWP_NOZORDER);
}


void AfxSetWindowClientSize (HWND hwnd, long nWidth, long nHeight, float rxRatio, float ryRatio)
{
    RECT     rc = {0};
    RECT     rcTemp = {0};
    SetRect( &rc, 0, 0, nWidth * rxRatio, nHeight * ryRatio);
    HANDLE   hMenu = GetMenu(hwnd);
    DWORD    dwStyle = GetWindowLongPtr(hwnd, GWL_STYLE);
    AdjustWindowRectEx( &rc, dwStyle, (hMenu != NULL), GetWindowLongPtr(hwnd, GWL_EXSTYLE));
    if(hMenu != NULL )
    {
        rcTemp = rc;
        rcTemp.bottom = 0x7FFF;
        SendMessage(hwnd, (UINT)WM_NCCALCSIZE, (WPARAM)0, (LPARAM)&rcTemp);
        rc.bottom +=   rcTemp.top;
    }
    if((dwStyle  BAND  WS_HSCROLL) == WS_HSCROLL )
    {
        rc.bottom = rc.bottom + GetSystemMetrics( SM_CYHSCROLL);
    }
    if((dwStyle  BAND  WS_VSCROLL) == WS_VSCROLL )
    {
        rc.right = rc.right + GetSystemMetrics( SM_CXVSCROLL);
    }
    long     cx = rc.right - rc.left;
    long     cy = rc.bottom - rc.top;
    SetWindowPos(hwnd, NULL, 0, 0, cx, cy, SWP_NOZORDER  BOR  SWP_NOMOVE  BOR  SWP_NOACTIVATE);
}


BOOL AfxIsProcessDPIAware ()
{
    HMODULE  pLib = LoadLibrary(_T("user32.dll"));
    BOOL     bRet = {0};
    if(pLib == 0 )
    {
        return 0;
    }
    BC9_AfxIsProcessDPIAware  pProc = {0};
    pProc = ( BC9_AfxIsProcessDPIAware) GetProcAddress( pLib, "IsProcessDPIAware");
    if(pProc == 0 )
    {
        return 0;
    }
    bRet = pProc();
    FreeLibrary(pLib);
    return bRet;
}


BOOL AfxUseDpiScaling ()
{
    HKEY     hkRes = {0};
    DWORD    dwType = {0};
    DWORD    dwData = {0};
    DWORD    cbData = {0};
    if(RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\DWM"), 0, KEY_QUERY_VALUE, &hkRes) == ERROR_SUCCESS )
    {
        if(hkRes )
        {
            cbData = sizeof( cbData);
            long     hr = RegQueryValueEx(hkRes, _T("UseDpiScaling"), 0, &dwType, (BYTE*)&dwData, &cbData);
            RegCloseKey(hkRes);
            if(hr == ERROR_SUCCESS )
            {
                return (dwData != 0);
            }
        }
    }
    return 0;
}


long AfxWindowsVersion ()
{
    DWORD    dwVersion = {0};
    long     nMajorVer = {0};
    long     nMinorVer = {0};
    dwVersion = GetVersion();
    nMajorVer = LOBYTE( LOWORD( dwVersion));
    nMinorVer = HIBYTE( LOWORD( dwVersion));
    return (nMajorVer + nMinorVer / 100) * 100;
}


ATOM CWindow_RegisterClass (_TCHAR* szClassName, HINSTANCE  hInstance, WNDPROC  lpfnWndProc)
{
    ATOM     wAtom = {0};
    WNDCLASSEXW  wcexw = {0};
    static long     nCount = 0;
    static _TCHAR     m_wszClassName[256];
    if(_tcslen(szClassName))
    {
        _tcscpy(m_wszClassName, szClassName);
    }
    else
    {
        _tcscpy(m_wszClassName, _T("bc9WindowClass"));
        _tcscpy(m_wszClassName, join(3, m_wszClassName, _T(":"), str(nCount)));
    }
    if(lpfnWndProc == NULL )
    {
        lpfnWndProc = ( WNDPROC)& CWindow_WindowProc;
    }
    wcexw.cbSize = sizeof( wcexw);
    wcexw.style = CS_DBLCLKS BOR CS_HREDRAW BOR CS_VREDRAW;
    wcexw.lpfnWndProc = lpfnWndProc;
    wcexw.cbClsExtra = 0;
    wcexw.cbWndExtra = sizeof( HANDLE);
    wcexw.hInstance = hInstance;
    wcexw.hCursor = LoadCursor( NULL, ( LPCWSTR) IDC_ARROW);
    wcexw.hbrBackground = ( HBRUSH)( COLOR_3DFACE + 1);
    wcexw.lpszMenuName = NULL;
    wcexw.lpszClassName = ( LPCWSTR)& m_wszClassName;
    wcexw.hIcon = 0;
    wcexw.hIconSm = 0;
    wAtom = RegisterClassEx(  &wcexw);
    if(wAtom )
    {
        nCount +=   1;
    }
    return wAtom;
}


LRESULT CWindow_WindowProc (HWND hwnd, UINT uMsg, WPARAM  wParam, LPARAM  lParam)
{
    static CWindow*  pWindow;
#ifdef USEMDI
    static HWND     hwndClient;
    HWND     hwndActive = {0};
    HANDLE   hMdi = {0};
    if(hwndClient == NULL && pWindow != NULL )
    {
        hwndClient\pWindow->hwndClient;
    }
#endif
    if(uMsg == WM_CREATE )
    {
        CREATESTRUCT*  pCreateStruct = (CREATESTRUCT*)lParam;
        pWindow = ( CWindow*) pCreateStruct->lpCreateParams;
        return 0;
    }
    if(uMsg == WM_SYSCOMMAND )
    {
        if(wParam == SC_CLOSE )
        {
            SendMessage(hwnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
            return 0;
        }
        goto L1000;
    }
    if(uMsg == WM_COMMAND )
    {
        if(LOWORD(wParam) == IDCANCEL )
        {
            if(HIWORD(wParam) == BN_CLICKED )
            {
                SendMessage(hwnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
                return 0;
            }
        }
#ifdef USEMDI
        if(hwndClient )
        {
            hwndActive = ( HANDLE) SendMessage( hwndClient, ( UINT) WM_MDIGETACTIVE, ( WPARAM) 0, ( LPARAM) 0);
            if(IsWindow(hwndActive))
            {
                SendMessage(hwndActive, (UINT)WM_COMMAND, (WPARAM)wParam, (LPARAM)lParam);
            }
        }
#endif
        goto L1000;
    }
    if(uMsg == WM_NOTIFY )
    {
#ifdef USEMDI
        if(hwndClient )
        {
            hwndActive = ( HANDLE) SendMessage( hwndClient, ( UINT) WM_MDIGETACTIVE, ( WPARAM) 0, ( LPARAM) 0);
            if(IsWindow(hwndActive) != 0 )
            {
                SendMessage(hwndActive, (UINT)WM_NOTIFY, (WPARAM)wParam, (LPARAM)lParam);
            }
        }
#endif
#ifdef USEMDI
        goto L1000;
    }
    if(uMsg == WM_CLOSE )
    {
        if(hwndClient )
        {
            EnumChildWindows(hwndClient, CWindow_CloseEnumProc, 0);
            if(GetWindow(hwndClient, GW_CHILD))
            {
                return 0;
            }
        }
#endif
#ifdef USEMDI
        goto L1000;
    }
    if(uMsg == WM_QUERYENDSESSION )
    {
        if(hwndClient )
        {
            EnumChildWindows(hwndClient, CWindow_CloseEnumProc, 0);
            if(GetWindow(hwndClient, GW_CHILD))
            {
                return 0;
            }
        }
#endif
        goto L1000;
    }
    if(uMsg == WM_DESTROY )
    {
        PostQuitMessage(0);
        return 0;
    }
L1000:
    ;
#ifdef USEMDI
    if(hwndClient )
    {
        return DefFrameProc(hwnd, hwndClient, uMsg, wParam, lParam);
    }
    else
    {
        return DefWindowProc(hwnd, uMsg, wParam, lParam);
    }
#else
    return DefWindowProc(hwnd, uMsg, wParam, lParam);
#endif
}


CWindow::CWindow (_TCHAR* szClassName)
{
    _tcscpy(m_szClassName, szClassName);
    m_hInstance =::GetModuleHandle( NULL);
    if(AfxUseDpiScaling == 0 )
    {
        this->DPI(96);
    }
    else
    {
        this->DPI(-1);
    }
    if(_tcslen(m_szDefaultFontName) == 0 )
    {
        if(AfxWindowsVersion() >= 600 && AfxIsProcessDPIAware())
        {
            _tcscpy(m_szDefaultFontName, _T("Segoe UI"));
        }
        else
        {
            _tcscpy(m_szDefaultFontName, _T("Tahoma"));
        }
    }
    if(m_DefaultFontSize == 0 )
    {
        if(AfxWindowsVersion() >= 600 && AfxIsProcessDPIAware())
        {
            m_DefaultFontSize = 9;
        }
        else
        {
            m_DefaultFontSize = 8;
        }
    }
    INITCOMMONCONTROLSEX  icc = {0};
    icc.dwSize = sizeof( icc);
    icc.dwICC = ICC_NATIVEFNTCTL_CLASS | ICC_COOL_CLASSES | ICC_BAR_CLASSES | ICC_TAB_CLASSES | ICC_USEREX_CLASSES | ICC_WIN95_CLASSES | ICC_STANDARD_CLASSES | ICC_ANIMATE_CLASS | ICC_DATE_CLASSES | ICC_HOTKEY_CLASS |   ICC_LISTVIEW_CLASSES | ICC_PAGESCROLLER_CLASS | ICC_PROGRESS_CLASS | ICC_TREEVIEW_CLASSES | ICC_UPDOWN_CLASS;
    ::InitCommonControlsEx( &icc);
}
CWindow::~CWindow ()
{
    if(m_hFont )
    {
        ::DeleteObject(m_hFont);
    }
    if(m_hAccel )
    {
        ::DestroyAcceleratorTable(m_hAccel);
    }
    if(_tcslen(m_szClassName))
    {
        UnregisterClass(m_szClassName, m_hInstance);
    }
    if(m_hRichEditLib )
    {
        FreeLibrary(m_hRichEditLib);
    }
}
float CWindow::DPI ()
{
    return m_DPI;
}


void CWindow::DPI (float nDPI)
{
    HDC      hDC = {0};
    m_DPI = nDPI;
    hDC = GetDC( NULL);
    if(m_DPI < 0 )
    {
        m_DPI = GetDeviceCaps( hDC, LOGPIXELSX);
        nDPI = m_DPI;
    }
    if(nDPI < 0 )
    {
        m_rx = ( GetDeviceCaps( hDC, LOGPIXELSX) / 96);
        m_ry = ( GetDeviceCaps( hDC, LOGPIXELSY) / 96);
    }
    else
    {
        m_rx = nDPI / 96;
        m_ry = nDPI / 96;
    }
    ReleaseDC(NULL, hDC);
}


LONG_PTR CWindow::UserData (long idx)
{
    if(idx < 0 || idx > 99 )
    {
        return 0;
    }
    return m_rgUserData[idx];
}


void CWindow::UserData (long idx, LONG_PTR  newValue)
{
    if(idx < 0 || idx > 99 )
    {
        return;
    }
    m_rgUserData[idx] = newValue;
}


long CWindow::Do_Events (long nCmdShow)
{
    MSG      uMsg = {0};
    if(m_hwnd == NULL )
    {
        return 0;
    }
    if(nCmdShow == 0 )
    {
        ShowWindow(m_hwnd, SW_SHOW);
    }
    else
    {
        ShowWindow(m_hwnd, nCmdShow);
    }
    while((GetMessage( &uMsg, NULL, 0, 0)))
    {
#ifdef USEMDI
        if(m_hwndClient == NULL || TranslateMDISysAccel(m_hwndClient, &uMsg) == 0 )
        {
#endif
            if(m_hAccel == NULL || TranslateAccelerator(m_hwnd, m_hAccel, &uMsg) == 0 )
            {
#if (USEDLGMSG >= 1)
                if(IsDialogMessage(m_hwnd, &uMsg) == 0 )
                {
                    TranslateMessage( &uMsg);
                    DispatchMessage( &uMsg);
                }
#else
                TranslateMessage( &uMsg);
                DispatchMessage( &uMsg);
#endif
            }
#ifdef USEMDI
        }
#endif
    }

    return uMsg.wParam;
}


HWND CWindow::Create (HWND hParent, _TCHAR* sTitle, WNDPROC  lpfnWndProc, long x, long y, long nWidth, long nHeight, DWORD dwStyle, DWORD dwExStyle)
{
    if(m_hwnd != NULL )
    {
        return 0;
    }
    m_wAtom = CWindow_RegisterClass( m_szClassName, m_hInstance, lpfnWndProc);
    if(m_wAtom == 0 )
    {
        return 0;
    }
    if(m_hFont == NULL )
    {
        m_hFont = this->CreateFont( m_szDefaultFontName, m_DefaultFontSize, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET);
    }
    m_hwnd =::CreateWindowEx( dwExStyle, ( LPCWSTR)( ULONG_PTR)( WORD) m_wAtom, sTitle, dwStyle, iif( x == CW_USEDEFAULT, ( int) CW_USEDEFAULT, ( int)( x * m_rx)), iif( y == CW_USEDEFAULT, ( int) CW_USEDEFAULT, ( int)( y * m_ry)), iif( nWidth == CW_USEDEFAULT, ( int) CW_USEDEFAULT, ( int)( nWidth * m_rx)), iif( nHeight == CW_USEDEFAULT, ( int) CW_USEDEFAULT, ( int)( nHeight * m_ry)), hParent, NULL, m_hInstance, ( HANDLE) this);
    if(m_hwnd == NULL )
    {
        return 0;
    }
    ::GetClassName(m_hwnd, (LPWSTR)&m_szClassName, sizeof(m_szClassName) / 2);
    if(m_hFont )
    {
        ::SendMessage(m_hwnd, WM_SETFONT, (WPARAM)m_hFont, FALSE);
    }
    ::SetWindowLongPtr(m_hwnd, 0, (LONG_PTR)this);
    return m_hwnd;
}


void CWindow::SetClientSize (long nWidth, long nHeight)
{
    AfxSetWindowClientSize(m_hwnd, nWidth, nHeight, m_rx, m_ry);
}


void CWindow::Center (HWND hwnd, HWND hwndParent)
{
    if(hwnd == NULL )
    {
        hwnd = m_hwnd;
    }
    AfxCenterWindow(hwnd, hwndParent);
}


HINSTANCE CWindow::InstanceHandle ()
{
    return m_hInstance;
}


void CWindow::InstanceHandle (HINSTANCE  hInst)
{
    if(m_hInstance == NULL )
    {
        m_hInstance = hInst;
    }
}


ULONG_PTR CWindow::ClassStyle ()
{
    if(m_hwnd == NULL )
    {
        return 0;
    }
    return GetClassLongPtr(m_hwnd, GCL_STYLE);
}


void CWindow::ClassStyle (ULONG_PTR  dwStyle)
{
    if(m_hwnd == NULL )
    {
        return;
    }
    SetClassLongPtr(m_hwnd, GCL_STYLE, dwStyle);
}


ULONG_PTR CWindow::WindowStyle ()
{
    if(m_hwnd == NULL )
    {
        return 0;
    }
    return GetWindowLongPtr(m_hwnd, GWL_STYLE);
}


void CWindow::WindowStyle (ULONG_PTR  dwStyle)
{
    if(m_hwnd == NULL )
    {
        return;
    }
    SetWindowLongPtr(m_hwnd, GWL_STYLE, dwStyle);
}


ULONG_PTR CWindow::WindowExStyle ()
{
    if(m_hwnd == NULL )
    {
        return 0;
    }
    return GetWindowLongPtr(m_hwnd, GWL_EXSTYLE);
}


void CWindow::WindowExStyle (ULONG_PTR  dwExStyle)
{
    if(m_hwnd == NULL )
    {
        return;
    }
    SetWindowLongPtr(m_hwnd, GWL_EXSTYLE, dwExStyle);
}


_TCHAR* CWindow::DefaultFontName ()
{
    return m_szDefaultFontName;
}


void CWindow::DefaultFontName (_TCHAR* fsFontName)
{
    _tcscpy(m_szDefaultFontName, fsFontName);
}


long CWindow::DefaultFontSize ()
{
    return m_DefaultFontSize;
}


void CWindow::DefaultFontSize (long nPointSize)
{
    m_DefaultFontSize = nPointSize;
}


HFONT CWindow::Font ()
{
    return m_hFont;
}


void CWindow::Font (HFONT  hFont)
{
    if(m_hFont )
    {
        DeleteObject(m_hFont);
    }
    m_hFont = hFont;
}


HBRUSH CWindow::Brush ()
{
    if(m_hwnd == NULL )
    {
        return 0;
    }
    return (HBRUSH)GetClassLongPtr(m_hwnd, GCLP_HBRBACKGROUND);
}


void CWindow::Brush (HBRUSH  hbrBackground)
{
    if(m_hwnd == NULL )
    {
        return;
    }
    SetClassLongPtr(m_hwnd, GCLP_HBRBACKGROUND, (LONG_PTR)hbrBackground);
    InvalidateRect(m_hwnd, NULL, TRUE);
    UpdateWindow(m_hwnd);
}


void CWindow::BigIcon (HICON  hIcon)
{
    SendMessage(m_hwnd, (UINT)WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hIcon);
}


void CWindow::SmallIcon (HICON  hIcon)
{
    SendMessage(m_hwnd, (UINT)WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)hIcon);
}


float CWindow::rxRatio ()
{
    return m_rx;
}


void CWindow::rxRatio (float rx)
{
    m_rx = rx;
}


float CWindow::ryRatio ()
{
    return m_ry;
}


void CWindow::ryRatio (float ry)
{
    m_ry = ry;
}


float CWindow::ScaleX (float cx)
{
    return cx * m_rx;
}


float CWindow::ScaleY (float cy)
{
    return cy * m_ry;
}


float CWindow::UnScaleX (float cx)
{
    return cx / m_rx;
}


float CWindow::UnScaleY (float cy)
{
    return cy / m_ry;
}


long CWindow::Width ()
{
    RECT     rc = {0};
    ::GetWindowRect(m_hwnd, &rc);
    return (rc.right - rc.left) / m_rx;
}


long CWindow::Height ()
{
    RECT     rc = {0};
    ::GetWindowRect(m_hwnd, &rc);
    return (rc.bottom - rc.top) / m_ry;
}


long CWindow::ClientWidth ()
{
    RECT     rc = {0};
    ::GetClientRect(m_hwnd, &rc);
    return (rc.right - rc.left) / m_rx;
}


long CWindow::ClientHeight ()
{
    RECT     rc = {0};
    ::GetClientRect(m_hwnd, &rc);
    return (rc.bottom - rc.top) / m_ry;
}


long CWindow::ControlWidth (HWND hwnd)
{
    RECT     rc = {0};
    ::GetWindowRect(hwnd, &rc);
    return (rc.right - rc.left) / m_rx;
}


long CWindow::ControlHeight (HWND hwnd)
{
    RECT     rc = {0};
    ::GetWindowRect(hwnd, &rc);
    return (rc.bottom - rc.top) / m_ry;
}


long CWindow::ControlClientWidth (HWND hwnd)
{
    RECT     rc = {0};
    ::GetClientRect(hwnd, &rc);
    return (rc.right - rc.left) / m_rx;
}


long CWindow::ControlClientHeight (HWND hwnd)
{
    RECT     rc = {0};
    ::GetClientRect(hwnd, &rc);
    return (rc.bottom - rc.top) / m_ry;
}


void CWindow::GetWindowRect (LPRECT  lpRect)
{
    if(lpRect == NULL )
    {
        return;
    }
    ::GetWindowRect(m_hwnd, lpRect);
    lpRect->left /= m_rx;
    lpRect->right /= m_rx;
    lpRect->top /= m_ry;
    lpRect->bottom /= m_ry;
}


RECT CWindow::GetWindowRect ()
{
    RECT     rc = {0};
    ::GetWindowRect(m_hwnd, &rc);
    rc.left /= m_rx;
    rc.right /= m_rx;
    rc.top /= m_ry;
    rc.bottom /= m_ry;
    return rc;
}


void CWindow::GetClientRect (LPRECT  lpRect)
{
    if(lpRect == NULL )
    {
        return;
    }
    ::GetClientRect(m_hwnd, lpRect);
    lpRect->left /= m_rx;
    lpRect->right /= m_rx;
    lpRect->top /= m_ry;
    lpRect->bottom /= m_ry;
}


RECT CWindow::GetClientRect ()
{
    RECT     rc = {0};
    ::GetClientRect(m_hwnd, &rc);
    rc.left /= m_rx;
    rc.right /= m_rx;
    rc.top /= m_ry;
    rc.bottom /= m_ry;
    return rc;
}


void CWindow::GetControlWindowRect (HWND hwnd, LPRECT  lpRect)
{
    if(lpRect == NULL )
    {
        return;
    }
    ::GetWindowRect(hwnd, lpRect);
    lpRect->left /= m_rx;
    lpRect->right /= m_rx;
    lpRect->top /= m_ry;
    lpRect->bottom /= m_ry;
}


RECT CWindow::GetControlWindowRect (HWND hwnd)
{
    RECT     rc = {0};
    ::GetWindowRect(hwnd, &rc);
    rc.left /= m_rx;
    rc.right /= m_rx;
    rc.top /= m_ry;
    rc.bottom /= m_ry;
    return rc;
}


void CWindow::GetControlClientRect (HWND hwnd, LPRECT  lpRect)
{
    if(lpRect == NULL )
    {
        return;
    }
    ::GetClientRect(hwnd, lpRect);
    lpRect->left /= m_rx;
    lpRect->right /= m_rx;
    lpRect->top /= m_ry;
    lpRect->bottom /= m_ry;
}


RECT CWindow::GetControlClientRect (HWND hwnd)
{
    RECT     rc = {0};
    ::GetClientRect(hwnd, &rc);
    rc.left /= m_rx;
    rc.right /= m_rx;
    rc.top /= m_ry;
    rc.bottom /= m_ry;
    return rc;
}


void CWindow::GetWorkArea (LPRECT  lpRect)
{
    if(lpRect == NULL )
    {
        return;
    }
    SystemParametersInfo(SPI_GETWORKAREA, 0, lpRect, 0);
    lpRect->left /= m_rx;
    lpRect->right /= m_rx;
    lpRect->top /= m_ry;
    lpRect->bottom /= m_ry;
}


RECT CWindow::GetWorkArea ()
{
    RECT     rc = {0};
    SystemParametersInfo(SPI_GETWORKAREA, 0, &rc, 0);
    rc.left /= m_rx;
    rc.right /= m_rx;
    rc.top /= m_ry;
    rc.bottom /= m_ry;
    return rc;
}


HWND CWindow::ControlHandle (long cID)
{
    return ::GetDlgItem(m_hwnd, cID);
}


void CWindow::Resize ()
{
    ::SendMessage(m_hwnd, WM_SIZE, (WPARAM)SIZE_RESTORED, MAKELONG(this->ClientWidth(), this->ClientHeight()));
}


BOOL CWindow::SetWindowPos (HWND hwnd, HWND hwndInsertAfter, long x, long y, long cx, long cy, UINT uFlags)
{
    return ::SetWindowPos(hwnd, hwndInsertAfter, x * m_rx, y * m_ry, cx * m_rx, cy * m_ry, uFlags);
}


BOOL CWindow::MoveWindow (HWND hwnd, long x, long y, long nWidth, long nHeight, BOOL bRepaint)
{
    return ::MoveWindow(hwnd, x * m_rx, y * m_ry, nWidth * m_rx, nHeight * m_ry, bRepaint);
}


HFONT CWindow::CreateFont (_TCHAR* szFaceName, long lPointSize, long lWeight, BYTE bItalic, BYTE bUnderline, BYTE bStrikeOut, BYTE bCharSet)
{
    LOGFONTW  tlfw = {0};
    _TCHAR    sFaceName[cSizeOfDefaultString] = {0};
    if(_tcslen(szFaceName))
    {
        _tcscpy(sFaceName, szFaceName);
    }
    else
    {
        _tcscpy(sFaceName, m_szDefaultFontName);
    }
    HDC      hDC = GetDC(HWND_DESKTOP);
    lPointSize = ( lPointSize * m_DPI) /::GetDeviceCaps( hDC, LOGPIXELSY);
    tlfw.lfHeight = - MulDiv( lPointSize, ::GetDeviceCaps( hDC, LOGPIXELSY), 72);
    tlfw.lfWidth = 0;
    tlfw.lfEscapement = 0;
    tlfw.lfOrientation = 0;
    tlfw.lfWeight = lWeight;
    tlfw.lfItalic = bItalic;
    tlfw.lfUnderline = bUnderline;
    tlfw.lfStrikeOut = bStrikeOut;
    tlfw.lfCharSet = bCharSet;
    tlfw.lfOutPrecision = OUT_TT_PRECIS;
    tlfw.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    tlfw.lfQuality = DEFAULT_QUALITY;
    tlfw.lfPitchAndFamily = FF_DONTCARE;
    _tcscpy(tlfw.lfFaceName, sFaceName);
    ::ReleaseDC(HWND_DESKTOP, hDC);
    return ::CreateFontIndirect( &tlfw);
}


BOOL CWindow::SetFont (_TCHAR* szFaceName, long lPointSize, long lWeight, BYTE bItalic, BYTE bUnderline, BYTE bStrikeOut, BYTE bCharSet)
{
    HFONT    hFont = {0};
    _TCHAR    strFaceName[cSizeOfDefaultString] = {0};
    if(_tcslen(szFaceName))
    {
        _tcscpy(strFaceName, szFaceName);
    }
    else
    {
        _tcscpy(strFaceName, m_szDefaultFontName);
    }
    hFont = this->CreateFont( strFaceName, lPointSize, lWeight, bItalic, bUnderline, bStrikeOut, bCharSet);
    if(hFont )
    {
        if(m_hFont )
        {
            ::DeleteObject(m_hFont);
        }
        m_hFont = hFont;
        _tcscpy(m_szDefaultFontName, strFaceName);
        m_DefaultFontSize = lPointSize;
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}


HWND CWindow::AddControl (_TCHAR* szClassName, HWND hParent, long cID, _TCHAR* szTitle, long x, long y, long nWidth, long nHeight, long dwStyle, long dwExStyle, LONG_PTR  lpParam, WNDPROC  pWndProc, UINT_PTR  uIdSubclass, DWORD_PTR  dwRefData)
{
    HWND     hCtl = {0};
    if(_tcslen(szClassName) == 0 )
    {
        return 0;
    }
    if(hParent == NULL )
    {
        hParent = m_hwnd;
    }
    long     bSetFont = TRUE;
    _TCHAR    sClassName[cSizeOfDefaultString] = {0};
    _tcscpy(sClassName, ucase(szClassName));
    if(str_cmp(sClassName, _T("BUTTON")) == 0)
    {
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER;
        }
        if(dwStyle == BS_FLAT )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER | BS_FLAT;
        }
        if(dwStyle == BS_DEFPUSHBUTTON )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_CENTER | BS_VCENTER | BS_DEFPUSHBUTTON;
        }
        if(dwStyle == BS_OWNERDRAW )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_OWNERDRAW;
        }
        if(dwStyle == BS_SPLITBUTTON )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_CENTER | BS_VCENTER | BS_SPLITBUTTON;
        }
        if(dwStyle == BS_DEFSPLITBUTTON )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_CENTER | BS_VCENTER | BS_DEFSPLITBUTTON;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("CUSTOMBUTTON")) == 0 ||  str_cmp(sClassName, _T("OWNERDRAWBUTTON")) == 0)
    {
        _tcscpy(sClassName, _T("Button"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_OWNERDRAW;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("RADIOBUTTON")) == 0 ||  str_cmp(sClassName, _T("OPTION")) == 0)
    {
        _tcscpy(sClassName, _T("Button"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_AUTORADIOBUTTON | BS_LEFT | BS_VCENTER;
        }
        if(dwStyle == WS_GROUP )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_AUTORADIOBUTTON | BS_LEFT | BS_VCENTER | WS_GROUP;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("CHECKBOX")) == 0)
    {
        _tcscpy(sClassName, _T("Button"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX | BS_LEFT | BS_VCENTER;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("CHECK3STATE")) == 0)
    {
        _tcscpy(sClassName, _T("Button"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | BS_AUTO3STATE | BS_LEFT | BS_VCENTER;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("LABEL")) == 0)
    {
        _tcscpy(sClassName, _T("Static"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | SS_LEFT | WS_GROUP | SS_NOTIFY;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("BITMAPLABEL")) == 0)
    {
        _tcscpy(sClassName, _T("Static"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_GROUP | SS_BITMAP;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_TRANSPARENT;
        }
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("ICONLABEL")) == 0)
    {
        _tcscpy(sClassName, _T("Static"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_GROUP | SS_ICON;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_TRANSPARENT;
        }
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("CUSTOMLABEL")) == 0)
    {
        _tcscpy(sClassName, _T("Static"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_GROUP | SS_OWNERDRAW;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("FRAME")) == 0 ||  str_cmp(sClassName, _T("FRAMEWINDOW")) == 0)
    {
        _tcscpy(sClassName, _T("Static"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_CLIPSIBLINGS | WS_GROUP | SS_BLACKFRAME;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_TRANSPARENT;
        }
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("GROUPBOX")) == 0)
    {
        _tcscpy(sClassName, _T("Button"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_CLIPSIBLINGS | WS_GROUP | BS_GROUPBOX;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_TRANSPARENT;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("LINE")) == 0)
    {
        _tcscpy(sClassName, _T("Static"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | SS_ETCHEDFRAME;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_TRANSPARENT;
        }
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("EDIT")) == 0 ||  str_cmp(sClassName, _T("TEXTBOX")) == 0)
    {
        _tcscpy(sClassName, _T("Edit"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | ES_LEFT | ES_AUTOHSCROLL;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("EDITMULTILINE")) == 0 ||  str_cmp(sClassName, _T("MULTILINETEXTBOX")) == 0 ||  str_cmp(sClassName, _T("MEMO")) == 0)
    {
        _tcscpy(sClassName, _T("Edit"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | ES_LEFT | ES_AUTOHSCROLL | ES_MULTILINE | ES_NOHIDESEL | ES_WANTRETURN;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("COMBOBOX")) == 0)
    {
        if(dwStyle == -1 )
        {
            dwStyle = WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_BORDER | WS_TABSTOP | CBS_DROPDOWN | CBS_HASSTRINGS | CBS_SORT;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("COMBOBOXEX")) == 0 ||  str_cmp(sClassName, _T("COMBOBOXEX32")) == 0)
    {
        _tcscpy(sClassName, _T("ComboBoxEx32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_BORDER | WS_TABSTOP | CBS_DROPDOWNLIST;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("LISTBOX")) == 0)
    {
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_HSCROLL | WS_VSCROLL | WS_BORDER | WS_TABSTOP | LBS_STANDARD | LBS_HASSTRINGS | LBS_SORT | LBS_NOTIFY;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("PROGRESSBAR")) == 0 ||  str_cmp(sClassName, _T("MSCTLS_PROGRESS32")) == 0)
    {
        _tcscpy(sClassName, _T("msctls_progress32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("HEADER")) == 0 ||  str_cmp(sClassName, _T("SYSHEADER32")) == 0)
    {
        _tcscpy(sClassName, _T("SysHeader32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | CCS_TOP | HDS_HORZ | HDS_BUTTONS;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("TREEVIEW")) == 0 ||  str_cmp(sClassName, _T("SYSTREEVIEW32")) == 0)
    {
        _tcscpy(sClassName, _T("SysTreeView32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_BORDER | WS_TABSTOP | TVS_HASBUTTONS | TVS_HASLINES | TVS_LINESATROOT | TVS_SHOWSELALWAYS;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("LISTVIEW")) == 0 ||  str_cmp(sClassName, _T("SYSLISTVIEW32")) == 0)
    {
        _tcscpy(sClassName, _T("SysListView32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_CLIPCHILDREN | WS_TABSTOP | LVS_REPORT | LVS_SHOWSELALWAYS | LVS_SHAREIMAGELISTS | LVS_AUTOARRANGE | LVS_EDITLABELS | LVS_ALIGNTOP;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("TOOLBAR")) == 0 ||  str_cmp(sClassName, _T("TOOLBARWINDOW32")) == 0)
    {
        _tcscpy(sClassName, _T("ToolbarWindow32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CCS_TOP | WS_BORDER | TBSTYLE_FLAT | TBSTYLE_TOOLTIPS;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("REBAR")) == 0 ||  str_cmp(sClassName, _T("REBARWINDOW32")) == 0)
    {
        _tcscpy(sClassName, _T("ReBarWindow32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_BORDER | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CCS_NODIVIDER | RBS_VARHEIGHT | RBS_BANDBORDERS;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("DATETIMEPICKER")) == 0 ||  str_cmp(sClassName, _T("SYSDATETIMEPICK32")) == 0)
    {
        _tcscpy(sClassName, _T("SysDateTimePick32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | DTS_SHORTDATEFORMAT;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("MONTHCALENDAR")) == 0 ||  str_cmp(sClassName, _T("MONTHCAL")) == 0 ||  str_cmp(sClassName, _T("SYSMONTHCAL32")) == 0)
    {
        _tcscpy(sClassName, _T("SysMonthCal32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("IPADDRESS")) == 0 ||  str_cmp(sClassName, _T("SYSIPADDRESS32")) == 0)
    {
        _tcscpy(sClassName, _T("SysIPAddress32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("HOTKEY")) == 0 ||  str_cmp(sClassName, _T("MSCTLS_HOTKEY32")) == 0)
    {
        _tcscpy(sClassName, _T("msctls_hotkey32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        goto L1003;
    }
    if(str_cmp(sClassName, _T("ANIMATE")) == 0 ||  str_cmp(sClassName, _T("ANIMATION")) == 0 ||  str_cmp(sClassName, _T("SYSANIMATE32")) == 0)
    {
        _tcscpy(sClassName, _T("SysAnimate32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | ACS_TRANSPARENT;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("SYSLINK")) == 0)
    {
        _tcscpy(sClassName, _T("WC_LINK"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("PAGER")) == 0 ||  str_cmp(sClassName, _T("SYSPAGER")) == 0)
    {
        _tcscpy(sClassName, _T("SysPager"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | PGS_HORZ;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("TAB")) == 0 ||  str_cmp(sClassName, _T("TABCONTROL")) == 0 ||  str_cmp(sClassName, _T("SYSTABCONTROL32")) == 0)
    {
        _tcscpy(sClassName, _T("SysTabControl32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_GROUP | WS_TABSTOP | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | TCS_TABS | TCS_SINGLELINE | TCS_RAGGEDRIGHT;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = 0;
        }
        dwExStyle = dwExStyle | WS_EX_CONTROLPARENT;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("STATUSBAR")) == 0 ||  str_cmp(sClassName, _T("MSCTLS_STATUSBAR32")) == 0)
    {
        _tcscpy(sClassName, _T("msctls_statusbar32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CCS_BOTTOM | SBARS_SIZEGRIP;
        }
        dwExStyle = 0;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("SIZEBAR")) == 0 ||  str_cmp(sClassName, _T("SIZEBOX")) == 0 ||  str_cmp(sClassName, _T("SIZEGRIP")) == 0)
    {
        _tcscpy(sClassName, _T("Scrollbar"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | SBS_SIZEGRIP | SBS_SIZEBOXBOTTOMRIGHTALIGN;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        nWidth = GetSystemMetrics( SM_CXVSCROLL);
        nHeight = GetSystemMetrics( SM_CYHSCROLL);
        RECT     rcClient = this->GetClientRect();
        x = rcClient.right - nWidth;
        y = rcClient.bottom - nHeight;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("HSCROLLBAR")) == 0)
    {
        _tcscpy(sClassName, _T("Scrollbar"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | SBS_HORZ;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("VSCROLLBAR")) == 0)
    {
        _tcscpy(sClassName, _T("Scrollbar"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | SBS_VERT;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("TRACKBAR")) == 0 ||  str_cmp(sClassName, _T("MSCTLS_TRACKBAR32")) == 0)
    {
        _tcscpy(sClassName, _T("msctls_trackbar32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | TBS_AUTOTICKS | TBS_HORZ | TBS_BOTTOM | TBS_TOOLTIPS;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("UPDOWN")) == 0 ||  str_cmp(sClassName, _T("MSCTLS_UPDOWN32")) == 0)
    {
        _tcscpy(sClassName, _T("msctls_updown32"));
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | UDS_WRAP | UDS_ARROWKEYS | UDS_ALIGNRIGHT | UDS_SETBUDDYINT;
        }
        dwExStyle = 0;
        bSetFont = FALSE;
        goto L1003;
    }
    if(str_cmp(sClassName, _T("RICHEDIT")) == 0 ||  str_cmp(sClassName, _T("RichEdit50W")) == 0)
    {
#define ES_SAVESEL  0x00008000
        if(dwStyle == -1 )
        {
            dwStyle = WS_VISIBLE | WS_TABSTOP | ES_LEFT | WS_HSCROLL | WS_VSCROLL | ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_MULTILINE | ES_WANTRETURN | ES_NOHIDESEL | ES_SAVESEL;
        }
        if(dwExStyle == -1 )
        {
            dwExStyle = WS_EX_CLIENTEDGE;
        }
        _tcscpy(sClassName, _T("RichEdit50W"));
        m_hRichEditLib = ( HMODULE) LoadLibrary(_T("MSFTEDIT.DLL"));
    }
L1003:
    ;
    if(dwStyle == -1 )
    {
        dwStyle = 0;
    }
    if(dwExStyle == -1 )
    {
        dwExStyle = 0;
    }
    dwStyle = dwStyle | WS_CHILD;
    hCtl =::CreateWindowEx( dwExStyle, sClassName, szTitle, dwStyle, x * m_rx, y * m_ry, nWidth * m_rx, nHeight * m_ry, hParent, ( HMENU)( LONG_PTR) cID, m_hInstance, ( LPVOID) lpParam);
    if(hCtl == NULL )
    {
        return 0;
    }
    if(m_hFont )
    {
        if(bSetFont )
        {
            ::SendMessage(hCtl, WM_SETFONT, (WPARAM)m_hFont, TRUE);
        }
    }
    _tcscpy(sClassName, ucase(szClassName));
    if(str_cmp(sClassName, _T("LISTBOX")) == 0)
    {
        SetWindowPos(hCtl, NULL, x, y, nWidth, nHeight, SWP_NOZORDER);
        goto L1004;
    }
    if(str_cmp(sClassName, _T("DATETIMEPICKER")) == 0 ||  str_cmp(sClassName, _T("SYSDATETIMEPICK32")) == 0)
    {
        if(m_hFont )
        {
            SendMessage(hCtl, (UINT)DTM_SETMCFONT, (WPARAM)m_hFont, (LPARAM)TRUE);
        }
        goto L1004;
    }
    if(str_cmp(sClassName, _T("PROGRESSBAR")) == 0 ||  str_cmp(sClassName, _T("MSCTLS_PROGRESS32")) == 0)
    {
        ::SendMessage(hCtl, PBM_SETRANGE32, 0, 100);
        ::SendMessage(hCtl, PBM_SETPOS, 0, 0);
        goto L1004;
    }
    if(str_cmp(sClassName, _T("TRACKBAR")) == 0 ||  str_cmp(sClassName, _T("MSCTLS_TRACKBAR32")) == 0)
    {
        ::SendMessage(hCtl, TBM_SETRANGEMIN, TRUE, 0);
        ::SendMessage(hCtl, TBM_SETRANGEMAX, TRUE, 100);
        ::SendMessage(hCtl, TBM_SETPAGESIZE, 0, 10);
        goto L1004;
    }
    if(str_cmp(sClassName, _T("UPDOWN")) == 0 ||  str_cmp(sClassName, _T("MSCTLS_UPDOWN32")) == 0)
    {
        ::SendMessage(hCtl, UDM_SETBASE, 10, 0);
        ::SendMessage(hCtl, UDM_SETRANGE32, 100, 0);
        ::SendMessage(hCtl, UDM_SETPOS32, 0, 0);
        this->SetWindowPos(hCtl, NULL, x, y, nWidth, nHeight, SWP_NOZORDER);
        goto L1004;
    }
    if(str_cmp(sClassName, _T("HSCROLLBAR")) == 0 ||  str_cmp(sClassName, _T("VSCROLLBAR")) == 0)
    {
        SCROLLINFO  tsi = {0};
        tsi.cbSize = sizeof( tsi);
        tsi.fMask = SIF_PAGE  BOR  SIF_POS  BOR  SIF_RANGE;
        tsi.nMin = 0;
        tsi.nMax = 100;
        tsi.nPage = 0;
        tsi.nPos = 0;
        ::SetScrollInfo(hCtl, SB_CTL, &tsi, TRUE);
        goto L1004;
    }
    if(str_cmp(sClassName, _T("TOOLBAR")) == 0 ||  str_cmp(sClassName, _T("TOOLBARWINDOW32")) == 0)
    {
        long     nButtonWidth = {0};
        long     nButtonHeight = {0};
        nButtonWidth = LOWORD(::SendMessage( hCtl, TB_GETBUTTONSIZE, 0, 0)) * m_rx;
        nButtonHeight = HIWORD(::SendMessage( hCtl, TB_GETBUTTONSIZE, 0, 0)) * m_ry;
        ::SendMessage(hCtl, TB_SETBUTTONSIZE, 0, MAKELONG(nButtonWidth, nButtonHeight));
        ::SendMessage(hCtl, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);
        goto L1004;
    }
    if(str_cmp(sClassName, _T("BITMAPLABEL")) == 0)
    {
        HANDLE   hImage = {0};
        WORD     wID = {0};
        DWORD    dwID = {0};
        if(str_cmp(left(szTitle, 1), _T("#")) == 0)
        {
            wID = _ttol(mid( szTitle, 2));
            dwID = MAKELONG( wID, 0);
            hImage =::LoadImage( m_hInstance, ( LPCWSTR)( ULONG_PTR) dwID, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
        }
        else
        {
            hImage =::LoadImage( m_hInstance, szTitle, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
        }
        if(hImage )
        {
            ::SendMessage(hCtl, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hImage);
        }
        goto L1004;
    }
    if(str_cmp(sClassName, _T("ICONLABEL")) == 0)
    {
        HANDLE   hImage = {0};
        WORD     wID = {0};
        DWORD    dwID = {0};
        if(str_cmp(left(szTitle, 1), _T("#")) == 0)
        {
            wID = _ttol(mid( szTitle, 2));
            dwID = MAKELONG( wID, 0);
            hImage =::LoadImage( m_hInstance, ( LPCWSTR)( ULONG_PTR) dwID, IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR);
        }
        else
        {
            hImage =::LoadImage( m_hInstance, szTitle, IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR);
        }
        if(hImage )
        {
            ::SendMessage(hCtl, STM_SETIMAGE, IMAGE_ICON, (LPARAM)hImage);
        }
        goto L1004;
    }
    if(str_cmp(sClassName, _T("BITMAPBUTTON")) == 0)
    {
        HANDLE   hImage = {0};
        WORD     wID = {0};
        DWORD    dwID = {0};
        if(str_cmp(left(szTitle, 1), _T("#")) == 0)
        {
            wID = _ttol(mid( szTitle, 2));
            dwID = MAKELONG( wID, 0);
            hImage =::LoadImage( m_hInstance, ( LPCWSTR)( ULONG_PTR) dwID, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
        }
        else
        {
            hImage =::LoadImage( m_hInstance, szTitle, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
        }
        if(hImage )
        {
            ::SendMessage(hCtl, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hImage);
        }
        goto L1004;
    }
    if(str_cmp(sClassName, _T("ICONBUTTON")) == 0)
    {
        HANDLE   hImage = {0};
        WORD     wID = {0};
        DWORD    dwID = {0};
        if(str_cmp(left(szTitle, 1), _T("#")) == 0)
        {
            wID = _ttol(mid( szTitle, 2));
            dwID = MAKELONG( wID, 0);
            hImage =::LoadImage( m_hInstance, ( LPCWSTR)( ULONG_PTR) dwID, IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR);
        }
        else
        {
            hImage =::LoadImage( m_hInstance, szTitle, IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR);
        }
        if(hImage )
        {
            ::SendMessage(hCtl, BM_SETIMAGE, IMAGE_ICON, (LPARAM)hImage);
        }
    }
L1004:
    ;
    if(pWndProc != NULL )
    {
        if(uIdSubclass == 0xFFFFFFFF )
        {
            ::SetProp(hCtl, _T("OLDWNDPROC"), (HANDLE)::SetWindowLongPtr(hCtl, GWLP_WNDPROC, (LONG_PTR)pWndProc));
        }
        else
        {
            ::SetWindowSubclass(hCtl, (SUBCLASSPROC)pWndProc, uIdSubclass, dwRefData);
        }
    }
    return hCtl;
}


HACCEL CWindow::AccelHandle ()
{
    return m_hAccel;
}


void CWindow::AccelHandle (HACCEL  hAccel)
{
    m_hAccel = hAccel;
}


void CWindow::AddAccelerator (BYTE fvirt, WORD  wKey, WORD  cmd)
{
}


CWindow* AfxCWindowPtr (HWND hwnd)
{
    return (CWindow*)::GetWindowLongPtr(hwnd, 0);
}


CWindow* AfxCWindowPtr (LPARAM  lParam)
{
    CREATESTRUCT*  pCreateStruct = (CREATESTRUCT*)lParam;
    return (CWindow*)pCreateStruct->lpCreateParams;
}


CWindow* AfxCWindowPtr (CREATESTRUCT*  pCreateStruct)
{
    return (CWindow*)pCreateStruct->lpCreateParams;
}


CWindow* AfxCWindowOwnerPtr (HWND hwnd)
{
    if(hwnd == NULL )
    {
        return 0;
    }
    HWND     hRootOwner =::GetAncestor(hwnd, GA_ROOTOWNER);
    if(hRootOwner == NULL )
    {
        return 0;
    }
    return (CWindow*)::GetWindowLongPtr(hRootOwner, 0);
}


int WINAPI _tWinMain (HINSTANCE  hInst, HINSTANCE  hPrev, LPWSTR  CmdLine, int CmdShow)
{
    int      iRetVal = {0};
    HWND     hWin = {0};
    HWND     hButton = {0};
    CWindow  pWindow;
    hWin = pWindow.Create( NULL, _T("CWindow with a button"),  &WndProc);
    pWindow.SetClientSize(500, 320);
    pWindow.Center();
    hButton = pWindow.AddControl(_T("Button"), hWin, IDCANCEL, _T("&Close"), 350, 250, 75, 23);
    iRetVal = pWindow.Do_Events( CmdShow);
    return iRetVal;
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM  wParam, LPARAM  lParam)
{
    if(Msg == WM_COMMAND )
    {
        if(LOWORD(wParam) == IDCANCEL )
        {
            if(HIWORD(wParam) == BN_CLICKED )
            {
                SendMessage(hWnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
                return 0;
            }
        }
        goto L1005;
    }
    if(Msg == WM_DESTROY )
    {
        PostQuitMessage(0);
        return 0;
    }
L1005:
    ;
    return DefWindowProc(hWnd, Msg, wParam, lParam);
}



