' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_Edit_AutoSelect.bas
' Contents: Demonstrates the use of the Edit control with auto selection of text.
' Compiler: Ported to bc9Basic jcfuller 08/24/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <windowsx.h>					/*'For control macros */
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_EDIT1 = 1001
CONST IDC_EDIT2 = 1002
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hEdit
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Edit controls - Auto selection of text", &WndProc)
	pWindow.Center()

	' // Add an Edit control
	hEdit = pWindow.AddControl("Edit",hWin , IDC_EDIT1, "First Textbox", 20, 35, 305, 23)
	' // Add another Edit control
	pWindow.AddControl("Edit",hWin , IDC_EDIT2, "Second Textbox", 20, 75, 305, 23)
	' // Set the focus in the first edit control
	SetFocus(hEdit)
	' // Highlight the text
	Edit_SetSel(hEdit, 0, -1)

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case EN_SETFOCUS
					Select Case CBCTL
						Case IDC_EDIT1
							Edit_SetSel(CTLHNDL(IDC_EDIT1), 0, -1)
						Case IDC_EDIT2
							Edit_SetSel(CTLHNDL(IDC_EDIT2), 0, -1)
					End Select
					Exit Function
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
