' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ListBox.bas
' Contents: Template - CWindow with a ListBox
' Compiler: Ported to bc9Basic jcfuller 08/23/2016   
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <windowsx.h>					/*'For listbox macros*/ 
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================

$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_LISTBOX = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hListBox
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow with a ListBox", &WndProc)
	pWindow.ClassStyle(CS_DBLCLKS)   ' // Change the window style to avoid flicker
	pWindow.SetClientSize(320, 375)
	
	pWindow.Center()

	' Add a listbox
	hListBox = pWindow.AddControl("ListBox",hWin , IDC_LISTBOX)
	pWindow.SetWindowPos(hListBox, NULL, 8, 8, 300, 320, SWP_NOZORDER)
	
	'fill the listbox
	Dim wszText$
	Dim As Long i
	For i = 1 To 50
		wszText$ = "Item " & Right$("00" & Str$(i),2)
		ListBox_AddString(hListBox,wszText$) 
	Next

   	' // Select the first item
	ListBox_SetCurSel(hListBox, 0)

   ' Add a cancel button
	pWindow.AddControl("Button",hWin , IDCANCEL, "Dismiss", 233, 338, 75, 23)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDC_LISTBOX
					Select Case CBCTLMSG
						Case LBN_DBLCLK
							Raw As HWND hListBox = CTLHNDL(IDC_LISTBOX)
							Raw As Long curSel = ListBox_GetCurSel(hListBox)
							Raw As Long nLen = ListBox_GetTextLen(hListBox, curSel)
							Raw As char ptr pwszText = new char[nLen + 1]
							ListBox_GetText(hListBox,curSel,pwszText)
							MessageBox(CBHNDL,pwszText,"List Box Test", MB_OK)
							delete [] pwszText
							pwszText = NULL
							Exit Function
					End Select	
						
			End Select
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
