' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_PickIconDlg.bas
' Contents: Demonstrates the use of the Pick icon dialog.
' Compiler: Ported to bc9Basic jcfuller 08/23/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'DEPRECIATED
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/
	#include <shlobj.h>
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
	#pragma comment(lib,"shell32.lib")
$HEADER
'==============================================================================
$USE USE_AfxGetSystemDllPath
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_PICKDLG = 1001   ' // Pick icon dialog identifier
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Pick Icon File Dialog", &WndProc)	
	pWindow.SetClientSize(500, 320)
	pWindow.Center()
	' // Add buttons without position or size (it will be resized in the WM_SIZE message).
	pWindow.AddControl("Button",hWin , IDC_PICKDLG, "&Pick")
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Close")
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	static wszIconPath$
	static As Integer nIconIndex
	static As HICON hIcon
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDC_PICKDLG
					If CBCTLMSG = BN_CLICKED Then
						If Len(wszIconPath$) = 0 Then
							wszIconPath = AfxGetSystemDllPath("Shell32.dll")
						EndIf
						If Len(wszIconPath) = 0 Then
							Exit Function
						EndIf
						Raw As Long hr = PickIconDlg(CBHNDL, wszIconPath, 2048, &nIconIndex)
						If hr = 1 Then
							If hIcon Then
								DestroyIcon(hIcon)
							EndIf
							hIcon = ExtractIcon(GetModuleHandle(NULL), wszIconPath, nIconIndex)
							If hIcon Then
								SendMessage(CBHNDL, WM_SETICON, ICON_SMALL, (LPARAM) hIcon)
								SendMessage(CBHNDL, WM_SETICON, ICON_BIG, (LPARAM) hIcon)
							EndIf
						EndIf
						Exit Function
					EndIf
			End Select
		Case WM_SIZE
			If CBWPARAM <> SIZE_MINIMIZED Then
				Raw As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
				If pWindow Then
					pWindow->MoveWindow(CTLHNDL(IDC_PICKDLG), pWindow->ClientWidth() - 230, pWindow->ClientHeight() - 50, 75, 23, TRUE)
					pWindow->MoveWindow( CTLHNDL( IDCANCEL), pWindow->ClientWidth() - 120, pWindow->ClientHeight() - 50, 75, 23, TRUE)					
				EndIf
			EndIf
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
