' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_TaskDialog.bas
' Contents: Task dialog example.
' Remarks: Requires the use of a manifest.
' Compiler: Ported to bc9Basic jcfuller 08/28/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Task Dialog", &WndProc)
	pWindow.SetClientSize(500, 320)
	pWindow.Center()

	' // Add the buttons
	pWindow.AddControl("Button",hWin , IDOK, "&Click me", 280, 270, 75, 23)
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Exit", 380, 270, 75, 23)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDOK
					If CBCTLMSG = BN_CLICKED Then
						Dim As Integer nClickedButton
						Dim As HRESULT hr
						hr = TaskDialog(CBHNDL,NULL,"CWindow", "CWindow", _
							"An update for the CWindow framework has just been released", _
							TDCBF_YES_BUTTON BOR TDCBF_NO_BUTTON, _
							TD_INFORMATION_ICON, &nClickedButton)										
						If hr = S_OK Then
							Select Case nClickedButton
								CASE IDYES : MessageBox( 0, "You clicked the Yes button", "", MB_OK)
								CASE IDNO  : MessageBox( 0, "You clicked the No button", "", MB_OK)
								
							End Select
						EndIf
					EndIf
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
