' ########################################################################################
' Microsoft Windows
' File: CW_GraphCtxSkeleton.bas
' Contents: CWindow Graphic Control Skeleton
' Compiler: Ported to bc9Basic jcfuller 09/04/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
'$HEADER
'#include <gdiplus.h>
'#pragma comment(lib,"gdiplus.lib")
'//using namespace Gdiplus;
'$HEADER
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/
	#include <gdiplus.h> 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
	#pragma comment(lib,"gdiplus.lib")
	//using namespace Gdiplus;
$HEADER
'==============================================================================
$USE USE_CGraphCtx::hWindow USE_CGraphCtx::SetVirtualBufferSize
$USE USE_CGraphCtx::GetMemDC
$USE USE_CGraphCtx::GethBmp USE_CGraphCtx::GetBits USE_CGraphCtx::Clear
$USE USE_CGraphCtx::GetVirtualBufferWidth USE_CGraphCtx::GetVirtualBufferHeight
$USE USE_AfxCaptureDisplay USE_AfxGetBitmapWidth USE_AfxGetBitmapHeight USE_AfxDrawBitmap
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Gdiplus.bi>
$Include <Afx/CGraphCtx.bi>
'==============================================================================
CONST IDC_GRCTX = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow Graphic Control Skeleton", &WndProc)
	pWindow.SetClientSize(430, 250)
	pWindow.Center()

   ' // Add a graphic control
	DIM AS CGraphCtx pGraphCtx  = CGraphCtx(&pWindow, IDC_GRCTX, "", 0, 0, pWindow.ClientWidth(), pWindow.ClientHeight())
	pGraphCtx.Clear( RGB(255, 255, 255))

	' // Capture the desktop window and display it in the control
	DIM AS HBITMAP hBitmap  = AfxCaptureDisplay()
	pGraphCtx.SetVirtualBufferSize(AfxGetBitmapWidth(hBitmap), AfxGetBitmapHeight(hBitmap))
	AfxDrawBitmap(pGraphCtx.GetMemDC(), 0, 0, hBitmap)
	DeleteObject( hBitmap)

	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Dim As HDC hdc
	Dim As PAINTSTRUCT ps
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_SIZE
			IF wParam <> SIZE_MINIMIZED THEN
				DIM AS CWindow PTR pWindow  = AfxCWindowPtr(CBHNDL)
				IF pWindow Then
					pWindow->MoveWindow(GetDlgItem(CBHNDL, IDC_GRCTX), 0, 0, pWindow->ClientWidth(), pWindow->ClientHeight(), TRUE)
				EndIf
			END IF
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
'==============================================================================
