'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'demo using the IDictionary COM interface wrapped with a 
'bc9Basic class -> cBcxDic
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*  
$CPP
$NOMAIN
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "TCLIB.BAT $FILE$"
$HEADER
	#pragma comment(lib,"ole32.lib")
	#pragma comment(lib,"OleAut32.lib")
$HEADER
'==============================================================================
$USE USE_BcxDict
$Include <bc9Lib.bi>
'==============================================================================
'I chose to use a Sub and a reference so I could refrain 
'from pointer indirection "->"
'------------------------------------------------------------------------------
Sub TestIt(oDic As cBcxDic Ref)
	'Add three items
	oDic.Add("a","Athens")
	oDic.Add("b","Belgrade")
	oDic.Add("c","Cairo")
	'get the number of items
	? "Count = ";oDic.get_count()
	
	'see if "a" exists	
	If oDic.Exists("a") Then
		? "a exists"
	Else
		? "a does not exist"
	EndIf
	'Print the "b" item. The $ is so the ? command knows it's a string
	? oDic.get_item$("b")
	'replace the "b" key with "m"
	oDic.put_key("b","m")
	'add an item for the "m" key
	oDic.put_item("m","Mexico")
	'Print the "m" item. 
	? oDic.get_item$("m")
	'Remove the "a" key and the associated item
	oDic._Remove("a")
	'see if it is in fact gone
	If oDic.Exists("a") Then
		? "YES"
	Else
		? "ALL GONE"
	EndIf
End Sub
'==============================================================================
Function main()
	Raw As cBcxDic Ptr oDic 
	Dim As int RetVal = EXIT_SUCCESS

	OleInitialize(NULL)
	oDic = new cBcxDic	
	If Not oDic Then
		? "No oDic allocation" 
		RetVal = EXIT_FAILURE
	Else
		TestIt(*oDic)
		delete oDic
	End If	
		
	OleUninitialize()
	Pause
	Function = RetVal
End Function

