'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'File Open File Save, and Browse For Folder example
'These functions use the recommended COM interface.
'File Open/Save are part of the bc9Lib while BFF is a BCX staple.
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "TCLIB.BAT $FILE$"
$HEADER
	#include <Shlobj.h>
	#include <commctrl.h>   // Win32 Header File 
	#pragma comment(lib,"comctl32.lib")
	#pragma comment(lib,"gdi32.lib")
	#pragma comment(lib,"advapi32.lib")
	#pragma comment(lib,"ole32.lib")
	#pragma comment(lib,"shell32.lib")
$HEADER
'------------------------------------------------------------------------------
$USE USE_AfxGetWindowText
$USE USE_bc9FileSaveDialog
$USE USE_bc9FileOpenDialog
$USE USE_AfxGetCurDir
$USE USE_RECTSIZE
'------------------------------------------------------------------------------

$Include <Afx\CWindow.bi>
$Include <bc9Lib.bi>
'==============================================================================
ENUM
	IDC_OFD = 1001
	IDC_SFD
	IDC_BFF
	IDC_EXIT
END ENUM	
$IPRINT_OFF
'==============================================================================
CallBack Function WndProc()
	Raw AS fstring fsFile
	Select Case Msg
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL,IDC_EXIT
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHWND,WM_CLOSE,0,0)
					EndIf
					Exit Function
				Case IDC_OFD
					fsFile = bc9FileOpenDialog(CBHNDL)
					MsgBox(fsFile.lpStr())
					Exit Function
				Case IDC_SFD
					fsFile = bc9FileSaveDialog(CBHNDL)
					MsgBox(fsFile.lpStr())
					Exit Function
				Case IDC_BFF
					fsFile = BFF$("Folder Find",BIF_RETURNONLYFSDIRS BOR _
					                            BIF_DONTGOBELOWDOMAIN BOR _
					                            BIF_USENEWUI BOR _
					                            BIF_RETURNFSANCESTORS,AfxGetCurDir())
					MsgBox(fsFile.lpStr())
					Exit Function                            					
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
'==============================================================================
Function WinMain()
	CoInitialize(NULL)
	Dim As Int RetVal,i,nTop
	Dim As HWND hWin 
	Raw As CWindow pWindow 

	pWindow.SetFont("Tahoma",9)
	
	hWin = pWindow.Create(NULL,"Open/Save/Browse", &WndProc,0,0,300,230)
	'remove  window sizing from default style
	pWindow.WindowStyle(pWindow.WindowStyle() XOR WS_THICKFRAME)

	nTop = 30 
		pWindow.Center()
		pWindow.AddControl("Button",hWin , IDC_OFD, "Open File Dialog", 0, nTop, 120, 28)
	nTop += 30	
		pWindow.AddControl("Button",hWin , IDC_SFD, "Save File Dialog", 0, nTop, 120, 28)
	nTop += 30	
		pWindow.AddControl("Button",hWin , IDC_BFF, "Browse For Folder", 0, nTop, 120, 28)
	nTop += 50	
		pWindow.AddControl("Button",hWin , IDC_EXIT, "Dismiss", 0, nTop, 120, 28)
	'vcenter the buttons on the window
	For i = IDC_OFD To IDC_EXIT
		AfxCenterWindow(GetDlgItem(hWin,i),hWin,VCENTER)
	Next
   ' // Dispatch messages
    RetVal = pWindow.Do_Events(CmdShow)
   ' // Uninitialize the COM library
   CoUninitialize()
	
End Function
'==============================================================================
