'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'T01A.BAS,T01B.BAS and T01C.BAS are the same except for the use of an fstring ptr
'in T01B/C.BAS
'See the include\TCLib\String.h file for a complete listing of supported methods 
'------------------------------------------------------------------------------
'fPrintS, LineInput tests
'------------------------------------------------------------------------------ 
'All text file input/ouput is ascii ONLY. UNICODE is not supported but:
'UNICODE is supported internally. Create and use a UNICODE app and all your text will
'be UNICODE and all WinApi calls will call the "W" versions but all fPrintS and LineInput
' will save/read to ascii. LineInput retrieves ascii text then converts to UNICODE.
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "TCLIB.BAT $FILE$"
$NOMAIN
'==============================================================================
Function main()
	Dim As HANDLE hFile
	Dim As int i
	Raw As fstring Ptr sTmp = new fstring("")
	Dim As int retval
	Dim As fstring Ptr sFile = new fstring("TEST_01C.TXT")
	? "creating ";
	sFile->Print(_true)
	'Note the "*" after the fstring variable name sFile
	'this tells the translator to use the "->" operator instead of the dot "."
	OpenFile sFile* For OUTPUT As hFile
    If hFile = INVALID_HANDLE_VALUE Then
    	printf("Could not open %s file, error %d\n", sFile->lpStr(), GetLastError())
    	Pause
    	Function = EXIT_FAILURE
    End If
    'print 10 lines of text to a file using fPrintS
	For i = 1 To 10
		*sTmp = "Line #" + Str(i)
		fPrintS(hFile,sTmp)
	Next
    
	CloseHandle(hFile)
	? "It Looks like it was succesful" 
	? "Now lets append to the file"
	Pause
	OpenFile sFile* For APPEND As hFile
	For i = 11 To 20
		*sTmp = "Line #" + Str(i)
		fPrintS(hFile,sTmp)
	Next
	CloseHandle(hFile)
	? "Now lets read back what we wrote"
	Pause
	OpenFile sFile* For INPUT As hFile
    Do
		retval = LineInput(hFile,sTmp)
		If retval < 0 Then
			break
		EndIf
		sTmp->Print(_true)
    Loop

	? "All Done"
	delete sTmp
	delete sFile
	 
	Pause
End Function
