// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.5.6 (2016/09/09)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-1) 5.1.0
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with the
//           Microsoft (R) C/C++ Optimizing Compiler
//                           On MS Windows
//                    Using TCLib by Fred Harris
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#define _X(y) y
#include <windows.h>
#define   x64
#include "TCLib\stdio.h"
#include "TCLib\string.h"
#include "TCLib\stdlib.h"
#include "TCLib\memory.h"
#include "TCLib\malloc.h"
#include "TCLib\math.h"
#include "TCLib\tchar.h"
#include "TCLib\Strings.cpp"
typedef String fstring;
FILE* stdin;
FILE* stdout;
FILE* stderr;
//<---UNICODE AWARE
#define SFMT (const char*)"%s\r\n"
//>---UNICODE AWARE

// NO HEADERS START
#ifndef _WINDOWS_
//<---UNICODE AWARE
typedef _TCHAR *PCHAR, *LPCH, *PCH, *NPSTR, *LPSTR, *PSTR;
typedef unsigned long DWORD, *PDWORD, *LPDWORD;
typedef unsigned int UINT;
//>---UNICODE AWARE
#endif
// NO HEADERS END
// ***************************************************
// Compiler Defines
// ***************************************************
#ifndef __cplusplus
#error A C++ compiler is required
#endif

// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const _TCHAR* ccptr;
#define CCPTR const _TCHAR*
#define cfree free
//<---UNICODE AWARE
typedef char _char;
#define _strlen strlen
//>---UNICODE AWARE
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************


// *************************************************
//               Standard Prototypes
// *************************************************

int LineInput(HANDLE, fstring*, int = 2048);
_TCHAR*   BCX_TmpStr(size_t, size_t = 0, int = 1);
_TCHAR*   chr(int);
BOOL    Exist   (const _TCHAR*);
BOOL    Exist_A (_TCHAR*);
BOOL    Exist_B (_TCHAR*);
void    Pause (void);

// *************************************************
//                System Variables
// *************************************************

// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************


// *************************************************
//            User Global Variables
// *************************************************



// *************************************************
//               User Prototypes
// *************************************************

int     _tmain (void);

// *************************************************
//            User Global Initialized Arrays
// *************************************************



// *************************************************
//                 Runtime Functions
// *************************************************

#ifndef BCXTmpStrSize
#define BCXTmpStrSize  2048
#endif
_TCHAR *BCX_TmpStr (size_t Bites, size_t  iPad, int iAlloc)
{
    static int   StrCnt;
    static _TCHAR *StrFunc[BCXTmpStrSize];
    StrCnt = (StrCnt + 1) & (BCXTmpStrSize - 1);
    if(StrFunc[StrCnt]) {
        free (StrFunc[StrCnt]);
        StrFunc[StrCnt] = NULL;
    }
#if defined BCX_MAX_VAR_SIZE
    if(Bites * sizeof(_TCHAR) > BCX_MAX_VAR_SIZE)
    {
        _tprintf(_T("Buffer Overflow caught in BCX_TmpStr - requested space of %d EXCEEDS %d\n"), (int)(Bites * sizeof(_TCHAR)), BCX_MAX_VAR_SIZE);
        abort();
    }
#endif
    if(iAlloc) StrFunc[StrCnt] = (_TCHAR*)calloc(Bites + iPad + 1, sizeof(_TCHAR));
    return StrFunc[StrCnt];
}


_TCHAR *chr (int a)
{
    register _TCHAR *strtmp = BCX_TmpStr(2, 1, 1);
    strtmp[0]  = a;
    return strtmp;
}


void Pause(void)
{
    _tprintf(_T("\n%ls\n"), _T("Press any key to continue..."));
    _getwch();
}


BOOL Exist (const _TCHAR *szFilePath)
{
    if(_tcschr(szFilePath, '*') || _tcschr(szFilePath, '?'))
        return Exist_A ((_TCHAR*)szFilePath);
    return Exist_B ((_TCHAR*)szFilePath);
}

BOOL Exist_A (_TCHAR *szFilePath)
{
    WIN32_FIND_DATA W32FindData;
    HANDLE rc;
    rc = FindFirstFile(szFilePath, &W32FindData);
    if(rc == INVALID_HANDLE_VALUE) return FALSE;
    FindClose(rc);
    return TRUE;
}

BOOL Exist_B (_TCHAR *szFilePath)
{
    DWORD ret;
    ret = GetFileAttributes(szFilePath);
    if (ret != 0xffffffff) return TRUE;
    return FALSE;
}


int LineInput (HANDLE hFile, fstring*  sData, int ReadBufferSize)
{
    _char*   ReadBuffer = {0};
    DWORD    dwBytesRead = {0};
    DWORD    dwPtr = {0};
    long     where = {0};
    int      j = {0};
    ReadBuffer = new _char[ ReadBufferSize];
    dwPtr = SetFilePointer( hFile, NULL, NULL, FILE_CURRENT);
    if(FALSE == ReadFile(hFile, ReadBuffer, ReadBufferSize, &dwBytesRead, NULL))
    {
        return -3;
    }
    if(dwBytesRead == 0 )
    {
        return -1;
    }
    {
        int      i;
        for(i = 0; i < dwBytesRead; i++)
        {
            if(ReadBuffer[i] == 10 )
            {
                where = i;
                j = where;
                if(ReadBuffer[i - 1] == 13 )
                {
                    where = i + 1;
                    j = i - 1;
                }
                break;
            }
        }
    }
    SetFilePointer(hFile, dwPtr + where, NULL, FILE_BEGIN);
    ReadBuffer[j]  = 0;
    wchar_t*  wszTo = new wchar_t[j + 1];
    wszTo[j] = L'\0';
    MultiByteToWideChar(CP_ACP, 0, ReadBuffer, -1, wszTo, (int)j);
    *sData = wszTo;
    delete[] wszTo;
    delete []ReadBuffer;
    return 0;
}

// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

int _tmain ()
{
    fstring  fsListFile(_T("newlist.txt"));
    fstring  sFolder(_T("C:\\bc9Afx\\Projects\\"));
    fstring  sPath;
    fstring  fsData;
    fstring  fsFile;
    HANDLE   hFile = {0};
    int      retval = {0};
    hFile = CreateFile( fsListFile.lpStr(), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
    if(hFile == INVALID_HANDLE_VALUE )
    {
        _tprintf(_T("Could not open %ls file, error %d\\n"), fsListFile.lpStr(), GetLastError());
        Pause();
        return EXIT_FAILURE;
    }
    for(;;)
    {
        retval = LineInput( hFile,  &fsData);
        if(retval < 0 )
        {
            break;
        }
        sPath = sFolder + fsData + chr( 92) + fsData;
        fsFile = sPath + _T(".exe");
        if(!Exist(fsFile.lpStr()))
        {
            fsFile.Print( true);
        }
        else
        {
            _tprintf(_T("%ls"), _T("Deleting "));
            fsFile.Print( true);
            DeleteFile(fsFile.lpStr());
        }
        fsFile = sPath + _T(".cpp");
        if(!Exist(fsFile.lpStr()))
        {
            fsFile.Print( true);
        }
        else
        {
            _tprintf(_T("%ls"), _T("Deleting "));
            fsFile.Print( true);
            DeleteFile(fsFile.lpStr());
        }
        fsFile = sPath + _T(".res");
        if(!Exist(fsFile.lpStr()))
        {
            fsFile.Print( true);
        }
        else
        {
            _tprintf(_T("%ls"), _T("Deleting "));
            fsFile.Print( true);
            DeleteFile(fsFile.lpStr());
        }
    }

    CloseHandle(hFile);
    Pause();
    return EXIT_SUCCESS;
}



