' ########################################################################################
' Microsoft Windows
' File: CImageCtx.inc
' Contents: GDI+ image control
' Compiler: Ported to bc9Basic jcfuller 09/06/2016  
' Copyright (c) 2016 José Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
CONST GDIP_IMAGECTX_AUTOSIZE    = 0   ' // Autoadjusts the image to the width or height of the control
CONST GDIP_IMAGECTX_ACTUALSIZE  = 1   ' // Shows the image with its actual size
CONST GDIP_IMAGECTX_FITTOWIDTH  = 2   ' // Adjusts the image to the width of the control
CONST GDIP_IMAGECTX_FITTOHEIGHT = 3   ' // Adjusts the image to the height of the control
CONST GDIP_IMAGECTX_STRETCH     = 4   ' // Adjusts the image to the height and width of the control
'==============================================================================
Class CImageCtx
	private:
		Dim As HWND m_hCtl             ' // Handle to the control
		Dim As HFONT m_hFont              ' // Handle to the font used by the control
		Dim As GpImage PTR m_pImage       ' // Image object pointer
		Dim As ULONG_PTR m_token          ' // Token returned by GdiplusStartup
		Dim As COLORREF m_BkColor         ' // RGB background color
		Dim As LONG m_Fit                 ' // Fit to width/height
		Dim As LONG m_InterpolationMode   ' // Interpolation mode
	public:
		Dim Constructor CImageCtx(pWindow AS CWindow PTR, cID AS INTEGER, wszTitle As char ptr = "", _
                                  x AS LONG = 0,y AS LONG = 0,nWidth AS LONG = 0,nHeight AS LONG = 0, _
                                  dwStyle AS DWORD = 0,dwExStyle AS DWORD = 0, lpParam AS LONG_PTR = 0)	
        Dim Destructor ~CImageCtx()
        Dim Function hWindow() As HWND
        'Dim Function GetImagePtr () As GImage ptr                          
End Class
