'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Resource Dilaog using TCLIb and Jos's ported CLayout sizing class
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$USE USE_CreateArr
$Include <bc9Lib.bi>
$Include <Afx/CLayout.bi>
'==============================================================================
CONST IDD_DLG1              =  1000
CONST IDC_EDT1              =  1001
CONST IDC_EDT2              =  1002
CONST IDC_GRP1              =  1003
CONST IDC_BTN1              =  1004
CONST IDC_CBO1              =  1005
'==============================================================================

Function WinMain()
	Dim As int RetVal
	RetVal = DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_DLG1),0,(DLGPROC)DlgProc,0)
	Function = RetVal
End Function
'==============================================================================
DlgCallBack DlgProc()
	static As CLayout Ptr pLayout
	static pptMin As POINT
	Select Case CBMSG
		Case WM_INITDIALOG
			Raw As fstring sTxt
			For int i = 1 To 9
				sTxt = "Item " + fstring(i)
				SendMessage(CTLHNDL(IDC_CBO1),CB_ADDSTRING,0,(LPARAM)sTxt.lpStr())
			Next
            SetMinSize(CBHWND,pptMin)
			pLayout = new CLayout(CBHWND)
			DlgAnchor(pLayout,CBHWND, IDC_EDT1, AFX_ANCHOR_WIDTH)
			DlgAnchor(pLayout,CBHWND, IDC_EDT2, AFX_ANCHOR_HEIGHT_WIDTH)
			DlgAnchor(pLayout,CBHWND, IDC_BTN1, AFX_ANCHOR_BOTTOM_RIGHT)
			DlgAnchor(pLayout,CBHWND, IDC_GRP1, AFX_ANCHOR_HEIGHT_RIGHT)
			DlgAnchor(pLayout,CBHWND, IDC_CBO1, AFX_ANCHOR_RIGHT)
		Case WM_GETMINMAXINFO
            Raw As LPMINMAXINFO lpmmi = (LPMINMAXINFO)CBLPARAM
            lpmmi->ptMinTrackSize = pptMin
		Case WM_SIZE
			If pLayout Then
				pLayout->AdjustControls()
			EndIf
		Case WM_CLOSE
			EndDialog(CBHWND,0)
		Case WM_DESTROY
			delete pLayout
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL,IDC_BTN1
					PostMessage(CBHWND,WM_CLOSE,0,0)
			End Select
	End Select
End Function
'==============================================================================
Sub SetMinSize(hDlg As HWND,pptMin As POINT Ref)
    Raw As RECT rc
    GetWindowRect(hDlg,&rc)
    pptMin.x = rc.right - rc.left
    pptMin.y = rc.bottom - rc.top
End Sub 

