'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Address Book using CWindow
'Uses Fred's String Class
'==============================================================================
'You need to created   
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_AfxAddWindowExStyle USE_AfxGetFileSize 
'------------------------------------------------------------------------------
$Include <Afx/CWindow.bi>
'==============================================================================
ENUM
	ID_INDEX     =  100
	ID_COMPANY
	ID_LAST
	ID_LASTNAME
	ID_FIRSTNAME
	ID_FIRST
	ID_ADDRESS
	ID_CITY
	ID_COUNTY
	ID_STATE
	ID_ZIPCODE
	ID_PHONE1
	ID_PHONE2
	ID_EMAIL
	ID_URL
	ID_PRIOR
	ID_NEXT
	ID_ADD
	ID_UPDATE
	ID_FIND
	ID_DELETE
	ID_PRINT
	ID_CLOSE
END ENUM
CONST WM_OPENDB = WM_APP + 100
CONST WM_SHOWDB = WM_APP + 101
'==============================================================================
TYPE AddressType
    DIM FirstName 	AS STRING * 32
    DIM LastName  	AS STRING * 32
    DIM Company   	AS STRING * 64
    DIM Address   	AS STRING * 64
    DIM City		AS STRING * 32
    Dim County		As String * 32
    DIM State		AS STRING * 4
    DIM Zip   		AS STRING * 12
    DIM Phone1     	AS STRING * 24
    DIM Phone2     	AS STRING * 24
    DIM Email     	AS STRING * 64
    DIM Url       	AS STRING * 64
END TYPE
'==============================================================================

Function WinMain()
	Dim As int iRetVal,nTop,WinWidth,WinHeight,nLeft,LeftIncr,RCount
	Dim As HWND hWin
	Raw As CWindow pWindow

	WinWidth = 460
	pWindow.SetFont("Tahoma", 10)
	hWin = pWindow.Create(NULL, "Address Book", &WndProc,0,0,WinWidth,540)
	'remove  window sizing form default style
	pWindow.WindowStyle(pWindow.WindowStyle() XOR WS_THICKFRAME)
	pWindow.AddControl("Label",hWin, -ID_INDEX,"Record No.",WinWidth-186,10,90,16)
	pWindow.AddControl("Label",hWin, ID_INDEX,"0  /  0",WinWidth-100,8,70,20,WS_CHILD OR WS_VISIBLE OR SS_SUNKEN OR SS_CENTER)
	nTop = 48
	pWindow.AddControl("Label",hWin, -ID_COMPANY,"Company",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_COMPANY,"",119,nTop-4,263,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, ID_FIRST,"Fist Name",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_FIRSTNAME,"",119,nTop-4,263,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, ID_LAST,"Last Name",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_LASTNAME,"",119,nTop-4,263,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_ADDRESS,"Address",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_ADDRESS,"",119,nTop-4,263,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_CITY,"City",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_CITY,"",119,nTop-4,263,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_COUNTY,"County",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_COUNTY,"",119,nTop-4,263,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_STATE,"State",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_STATE,"",119,nTop-4,50,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_ZIPCODE,"Zip",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_ZIPCODE,"",119,nTop-4,100,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_PHONE1,"Phone #1",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_PHONE1,"",119,nTop-4,120,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_PHONE2,"Phone #2",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_PHONE2,"",119,nTop-4,120,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_EMAIL,"Email",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_EMAIL,"",119,nTop-4,263,24)
	nTop+=28
	pWindow.AddControl("Label",hWin, -ID_URL,"WWW",9,nTop,105,16)
	pWindow.AddControl("Edit", hWin, ID_URL,"",119,nTop-4,263,24)
	
	nTop+=50
	nLeft = 45
	LeftIncr = 95
	pWindow.AddControl("Button",hWin,ID_PRIOR,"<< Prior",nLeft, nTop, 70, 28)
	nLeft+=LeftIncr
	pWindow.AddControl("Button",hWin,ID_NEXT,"Next >>",nLeft, nTop, 70, 28)   	
	nLeft+=LeftIncr
	pWindow.AddControl("Button",hWin,ID_FIND,"Find",nLeft, nTop, 70, 28)   	
	nLeft+=LeftIncr
	pWindow.AddControl("Button",hWin,ID_ADD,"Add",nLeft, nTop, 70, 28)
	nTop+= 35
	nLeft = 45
	pWindow.AddControl("Button",hWin,ID_UPDATE,"Update",nLeft, nTop, 70, 28)
	nLeft+=LeftIncr
	pWindow.AddControl("Button",hWin,ID_DELETE,"Delete",nLeft,nTop, 70, 28)
	nLeft+=LeftIncr
	pWindow.AddControl("Button",hWin,ID_PRINT,"Print",nLeft, nTop, 70, 28)
	nLeft+=LeftIncr
	pWindow.AddControl("Button",hWin,IDCANCEL,"Close",nLeft, nTop, 70, 28)
	pWindow.Center()

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
	
End Function
'==============================================================================
CallBack Function WndProc()
	Static As HANDLE hFile
	Static As int iRecord,RCount
	Dim As int Where
	Dim Rec$
	Static As AddressType Ptr sAddress
	Select Case CBMSG
		Case WM_CREATE
			PostMessage(CBHNDL,WM_OPENDB,0,0)
			Function = 0
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case ID_NEXT
					iRecord++
					If iRecord = RCount Then
						iRecord = 0
					EndIf
					Where = iRecord * sizeof(AddressType)
					FSeek(hFile,Where)
					PostMessage(CBHNDL,WM_SHOWDB,0,0)
				Case ID_PRIOR
					iRecord--
					If iRecord = -1  Then
						iRecord = RCount-1
					End If	
					Where = iRecord * sizeof(AddressType)	
					FSeek(hFile,Where)
					PostMessage(CBHNDL,WM_SHOWDB,0,0)
			End Select
		Case WM_DESTROY
			CloseHandle(hFile)
			delete sAddress
			PostQuitMessage(0)
			Exit Function
		Case WM_SHOWDB
			FGet(hFile,sAddress,sizeof(AddressType))
			SetWindowText(CTLHNDL(ID_FIRSTNAME),sAddress->FirstName)
			SetWindowText(CTLHNDL(ID_LASTNAME),sAddress->LastName)
			SetWindowText(CTLHNDL(ID_COMPANY),sAddress->Company)
			SetWindowText(CTLHNDL(ID_ADDRESS),sAddress->Address)
			SetWindowText(CTLHNDL(ID_CITY),sAddress->City)
			SetWindowText(CTLHNDL(ID_COUNTY),sAddress->County)
			SetWindowText(CTLHNDL(ID_STATE),sAddress->State)
			SetWindowText(CTLHNDL(ID_ZIPCODE),sAddress->Zip)
			SetWindowText(CTLHNDL(ID_PHONE1),sAddress->Phone1)
			SetWindowText(CTLHNDL(ID_PHONE2),sAddress->Phone2)
			SetWindowText(CTLHNDL(ID_EMAIL),sAddress->Email)
			SetWindowText(CTLHNDL(ID_URL),sAddress->Url)
			Rec$ = USING$("###",iRecord+1) & "/" & Str$(RCount) 
			SetWindowText(CTLHNDL(ID_INDEX),Rec$)
		Case WM_OPENDB
			Raw As fstring sFile("Address50.bin")
			RCount = AfxGetFileSize(sFile.lpStr())/sizeof(AddressType)
			sAddress = new AddressType
			OpenFile sFile For Input As hFile
			iRecord = 0
			PostMessage(CBHNDL,WM_SHOWDB,0,0)
	End Select
End Function
