' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ButtonTooltip.bas
' Contents: CWindow button with tooltip
' Compiler: Ported to bc9Basic jcfuller 08/18/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_AfxAddTooltip
'------------------------------------------------------------------------------
$Include <Afx/CWindow.bi>
$Include <Afx/AfxCtl.bi>

'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hButton,hTooltip

	Raw As CWindow pWindow
	hWin = pWindow.Create(NULL, "CWindow with a button", &WndProc)
	pWindow.SetClientSize(500,320)
	pWindow.Center()

	'Add a button
	hButton = pWindow.AddControl("Button",hWin , IDCANCEL, "&Close", 350, 250, 75, 23)
	'Add a tooltip to the button
	hTooltip = AfxAddTooltip(hButton, "This is a button with a tooltip", TRUE, TRUE)
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
