' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_Edit_SetMargins.bas - Template
' Contents: Demonstrates how to set margins to an edit control
' Compiler: Ported to bc9Basic jcfuller 08/24/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_EDIT1 = 1001
CONST IDC_EDIT2 = 1002
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hEdit1,hEdit2
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Edit controls - Set margins", &WndProc)
	pWindow.Center()

	'Add Edit controls
	hEdit1 = pWindow.AddControl("Edit",hWin , IDC_EDIT1, "Margin 20", 20, 35, 305, 23)
	hEdit2 = pWindow.AddControl("Edit",hWin , IDC_EDIT2, "Margin 30", 20, 75, 305, 23)
	SendMessage(hEdit1, EM_SETMARGINS, EC_LEFTMARGIN BOR EC_RIGHTMARGIN, MAKELONG(20, 20))
	SendMessage(hEdit2, EM_SETMARGINS, EC_LEFTMARGIN BOR EC_RIGHTMARGIN, MAKELONG(30, 30))
	SetFocus(hEdit1)
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
