' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_Label.bas
' Contents: Demonstrates the use of the Label control.
' Compiler: FPorted to bc9Basic jcfuller 08/25/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
'Tell the translator to include SetColor from the bc9Lib.bi file
$USE USE_SetColor
'==============================================================================
$Include <Afx/CWindow.bi>
$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_LABEL = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hLabel
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow with a label control", &WndProc)
	pWindow.Center()

	'Add a label control
	hLabel = pWindow.AddControl("Label",hWin , IDC_LABEL, "This is a label", 100, 50, 150, 23)
	
	'I am using my bc9Lib SetColor function in the callback
	' Create a custom brush for the label
	'DIM AS LOGBRUSH tlb
	'tlb.lbStyle = BS_SOLID
	'tlb.lbColor = 0x00ED9564
	'DIM AS HBRUSH hBrush = CreateBrushIndirect(&tlb)
	'SetProp( hLabel, "BRUSH", hBrush)
	
	
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_CTLCOLORSTATIC
			'this is one of my bc9Lib routines SetColor(txtColr,bkColr,hdc)
			Function = (LRESULT)SetColor(0x00FFFFFF,0x00ED9564,(HDC)CBWPARAM)
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
