' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_RadioButton.bas
' Contents: Demonstrates the use of the RadioButton control (aka Option control).
' Compiler: Ported to bc9Basic jcfuller 08/26/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_GROUPBOX = 1001
CONST IDC_OPTION1 = 1002
CONST IDC_OPTION2 = 1003
CONST IDC_OPTION3 = 1003
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Radio buttons example", &WndProc)
	pWindow.Center()

	' // Add a group box control
	pWindow.AddControl("GroupBox",hWin , IDC_GROUPBOX, "Options", 10, 10, 325, 120)
	' // Add three radio buttons (the first one should have the WS_GROUP style)
	pWindow.AddControl("RadioButton",hWin , IDC_OPTION1, "Option 1", 60, 40, 75, 23, WS_GROUP)
	pWindow.AddControl("RadioButton",hWin , IDC_OPTION2, "Option 2", 60, 60, 75, 23)
	pWindow.AddControl("RadioButton",hWin , IDC_OPTION3, "Option 3", 60, 80, 75, 23)
	' // Check the first radio button
	CheckDlgButton( hWin, IDC_OPTION1, BST_CHECKED)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
