' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_RichEdit.bas
' Contents: CWindow Rich Edit example
' Compiler: Ported to bc9Basic jcfuller 08/26/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_RICHEDIT = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hRichEdit
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow with a Rich Edit control", &WndProc)
	pWindow.SetClientSize(500, 320)
	pWindow.Center()
	
	'Add a rich edit control without coordinates (it will be resized in WM_SIZE)
	hRichEdit = pWindow.AddControl("RichEdit",hWin , IDC_RICHEDIT, "RichEdit box")
	SetFocus(hRichEdit)	
	
	'Add a button without coordinates (it will be resized in WM_SIZE)
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Close", 0, 0, 75, 23)
		
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_SIZE
			If CBWPARAM <> SIZE_MINIMIZED Then
				Raw As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
				If pWindow Then
					pWindow->MoveWindow( CTLHNDL( IDC_RICHEDIT), 100, 50, pWindow->ClientWidth() - 200, pWindow->ClientHeight() - 150, TRUE)
					pWindow->MoveWindow( CTLHNDL( IDCANCEL), pWindow->ClientWidth() - 95, pWindow->ClientHeight() - 35, 75, 23, TRUE)
				EndIf
			EndIf
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
