' ########################################################################################
' Microsoft Windows
' File: CW_XpButton.bas
' Contents: CWindow XpButton example
' Compiler: Ported to bc9Basic jcfuller 08/23/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/
	#include <uxtheme.h> 					/*'For XpButton*/
	#include <vsstyle.h>					/*'For XpButton*/
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
	#pragma comment(lib,"uxtheme.lib")		/*'For XpButton*/
$HEADER
'==============================================================================

'==============================================================================
$Include <Afx/CWindow.bi>
$Include <Afx/CXpButton.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_BUTTON1 = 1001
CONST IDC_BUTTON2 = 1002
CONST IDC_BUTTON3 = 1003
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "XpButton example", &WndProc)
	pWindow.SetClientSize(215, 142)
	pWindow.Center()

   	' // Create the first button
   	DIM AS CXpButton pXpButton1 = CXpButton(&pWindow, IDC_BUTTON1, "&Ok", 50, 20, 114, 26)
	pXpButton1.SetIcon(LoadIcon(NULL, IDI_SHIELD), XPBI_NORMAL)
	pXpButton1.SetIcon( LoadIcon(NULL, IDI_QUESTION), XPBI_HOT)
	pXpButton1.SetToggle(TRUE)
	pXpButton1.SetCursor( LoadCursor(NULL, IDC_CROSS))
	pXpButton1.SetImageMargin( 10)

	' // Create the second button
	DIM AS CXpButton pXpButton2 = CXpButton(&pWindow, IDC_BUTTON2, "&Cancel", 50, 55, 114, 26)
	pXpButton2.SetIcon( LoadIcon(NULL, IDI_ERROR), XPBI_NORMAL)
	pXpButton2.SetImagePos( XPBI_RIGHT BOR XPBI_VCENTER)
	pXpButton2.SetTextFormat( DT_RIGHT BOR DT_VCENTER BOR DT_SINGLELINE)
	EnableWindow( pXpButton2.hWindow(), FALSE)   ' Disable the button

	' // Create the third button
	DIM AS CXpButton pXpButton3 = CXpButton(&pWindow, IDC_BUTTON3, "Classic", 50, 90, 114, 26)
	SetFocus( pXpButton1.hWindow())
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
