' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_Button.bas
' Contents: CWindow button example
' Compiler: Ported to bc9Basic jcfuller 08/16/2016 
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"
$ONEXIT "TCLIB.BAT $FILE$"
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER

$Include <Afx/CWindow.bi>

'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
   ' // Set process DPI aware
   ' // The recommended way is to use a manifest file
   'AfxSetProcessDPIAware

   ' // Creates the main window
   Raw As CWindow pWindow
   ' -or- DIM pWindow AS CWindow = "MyClassName" (use the name that you wish)
   hWin = pWindow.Create(NULL, "CWindow with a button", &WndProc)
   ' // Sizes it by setting the wanted width and height of its client area
   pWindow.SetClientSize(500, 320)
   ' // Centers the window
   pWindow.Center()

   ' // Adds a button
   pWindow.AddControl("Button",hWin, IDCANCEL, "&Close", 350, 250, 75, 23)

		
	   ' // Dispatch messages
    iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function
'==============================================================================
CallBack Function WndProc()
	Select Case Msg
		Case WM_CREATE
			' // If you want to create controls in WM_CREATE instead of in WinMain, you can
			' // retrieve a pointer of the class with AfxCWindowPtr(lParam). Use hwnd as the
			' // handle of the window instead of pWindow->hWindow or omitting this parameter
			' // because CWindow doesn't know the value of this handle until the WM_CREATE
			' // message has been processed.
			' DIM pWindow AS CWindow PTR = AfxCWindowPtr(lParam)
			' IF pWindow THEN pWindow->AddControl("Button", hwnd, IDCANCEL, "&Close", 350, 250, 75, 23)
			' // An alternative is no pass the value of the main window handle to CWindow with
			' DIM pWindow AS CWindow PTR = AfxCWindowPtr(lParam)
			' pWindow->hWindow = hwnd
			' IF pWindow THEN pWindow->AddControl("Button", , IDCANCEL, "&Close", 350, 250, 75, 23)
			Exit Function
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		'Case WM_SIZE
		Case WM_DESTROY
			' // Ends the application by sending a WM_QUIT message
			PostQuitMessage(0)
			Exit Function
			
	End Select
End Function
