' ########################################################################################
' Microsoft Windows
' File: CW_GDI_LineDemo.bas
' Contents: Line demonstration
' Compiler: Ported to bc9Basic jcfuller 09/02/2016
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################

$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'==============================================================================
Function WinMain()
	
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Line demonstration", &WndProc)
	pWindow.Brush((HBRUSH) GetStockObject(WHITE_BRUSH))
	pWindow.SetClientSize(400, 250)
	
	pWindow.Center()

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	static As Long cxClient,cyClient
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_SIZE
			cxClient = LOWORD(CBLPARAM)
			cyClient = HIWORD(CBLPARAM)
			Exit Function
		Case WM_PAINT
			DIM AS PAINTSTRUCT ps
			DIM AS HDC hdc = BeginPaint(CBHNDL, &ps)
			Rectangle( hdc, cxClient / 8, cyClient / 8, 7 * cxClient / 8, 7 * cyClient / 8)
			MoveToEx( hdc, 0, 0, NULL)
			LineTo( hdc, cxClient, cyClient)
			MoveToEx( hdc, 0, cyClient, NULL)
			LineTo( hdc, cxClient, 0)
			Ellipse( hdc, cxClient / 8, cyClient / 8, 7 * cxClient / 8, 7 * cyClient / 8)
			RoundRect( hdc, cxClient / 4, cyClient / 4, 3 * cxClient / 4, 3 * cyClient / 4, cxClient / 4, cyClient / 4)
			EndPaint(CBHNDL, &ps)
			EXIT FUNCTION
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
